<?php

require_once('_setup.php');
require_once('_https_switch.php');

define('ER_NO_DORMITORY_PERM', 			'ER_NO_DORMITORY_PERM');
define('ER_NO_FACULTY_PERM', 			'ER_NO_FACULTY_PERM');
define('ER_TECHNICAL_CONFIG_NEEDED',	'ER_TECHNICAL_CONFIG_NEEDED');

$session = new Session();
//$properties = Properties::retrieveProperties();

//$global_properties = $properties['global'];
$active_season_id = Properties::getProperty('active_season_id', 'global');
$global_properties['active_season'] = getSeasonDetails($active_season_id);

//$global_properties['active_season']['id'];

$state = 'index';
$menuState = '';
$section_error = '';

if (!empty($_POST['dologin'])) {
	
	$user = isCorrectAdminLogin($_POST['login'], $_POST['password']);
	
	if (!empty($user['admin_id'])) {
		$session->createAdminSession($user);
	}
	else {
		$menuState = 'login';
	}
}

if (!empty($_POST['logout'])) {
	$session->destroyAdminSession();
}

$admin_id = $session->getAdminId();
$logged_admin = getAdminDetails($admin_id, true);

$config = new Config($logged_admin['faculty']['id']);
$config->init();

$user_is_admin = false;

if ($admin_id == 1) {
	$user_is_admin = true;
}

if (empty($admin_id)) {
	$logged = false;
	$admin_id = 0;
//	$menuPanels = array('login', 'registration');
	$menuPanels = array('login', 'registration_new');
}
else {
	$logged = true;
	$menuPanels = array('user');
}

if (!empty($_GET['show_message'])) {
	$state = 'message_view';
}

$page = new XTemplate('out/tpl/admin.tpl');

if ($menuState == 'login') {
	
	$error = 'Zadali ste nesprvne prihlasovacie daje.';
			
	$page->assign('ERROR', $error);
	$page->assign('LOGINDATA', $_POST);
	$page->parse('main.login.error');
}

$activeSection = getActiveSection($_GET['section']);

$error = '';

if ($activeSection['error'] == 'OK') {
	if (!hasAdminRightToSection($admin_id, $activeSection['section_id'])) {
		$error = 'SECTION_ACCESS_DENIED';
		$state = 'error';
	}
	else {
		$state = $activeSection['section_tag'];
		$activeSection['url'] = 'admin.php?section='.$activeSection['section_id'];
		$page->assign('SECTION', $activeSection);
	}
}
elseif ($activeSection['error'] != 'NOT_EXISTS') {
	$state = 'error';
	$error = 'SECTION_NOT_EXISTS';
}

$userId = $_REQUEST['user_id'];
$studentId = $_GET['student_id'];
$action = $_REQUEST['action'];
$recordId = $_REQUEST['record_id'];

#############################################################################
## index state ##############################################################
#############################################################################

switch ($state) {
	
	case 'error':
		switch ($error) {
			case 'SECTION_ACCESS_DENIED':
			case 'SECTION_NOT_EXISTS':
				$page->assign('ERROR', 'Prstup odmietnut.');
			break;
			default:
				$page->assign('ERROR', 'Generick chyba.');
			
		}
		
		$page->parse('main.error');	
	break;
	
	case 'generic_records_computation':
		if (empty($logged_admin['faculty']['id']))
		{
			$section_error = ER_NO_FACULTY_PERM;
		}
		else
		{
			if (empty($config->modificators_class) && empty($config->records_class))
			{
				$section_error = ER_TECHNICAL_CONFIG_NEEDED;
			}
			else
			{
				$applications = array();
	
				if ($_REQUEST['generate_actual']) 
				{
					$applications = getApplications('present');
				}
				
				if ($_REQUEST['generate_new']) 
				{							
					$applications = getApplications('new');
				}
				
				if (count($applications) > 0)
				{
					$modificators_class = 'Modificators';
					$records_class = 'Records';
					
					if (!empty($config->modificators_class))
					{
						$modificators_class = $config->modificators_class;
					}
					
					if (!empty($config->records_class))
					{
						$records_class = $config->records_class;
					}
					
					$modificators = new $modificators_class($db);
					$records = new $records_class($db);
					
					foreach ($applications as $application)
					{
						$modificators->assignUser($application);
						$records->assignUser($application);
						
						$modificators->generateGenericModificators();
						$records->generateGenericRecords();
					}
	
					header('Location: '.$activeSection['url'].'&action=show_message');
					exit();
				}
	
				if ($action == 'show_message')
				{
					$page->parse('main.generic_modificators_computation.message');
				}
				
				$page->assign('DESCRIPTION', $config->generic_records_description);
				
				$page->parse('main.generic_modificators_computation');
			}
		}
	break;
	
	case 'applications_info':

		if (empty($logged_admin['faculty']['id']))
		{
			$section_error = ER_NO_FACULTY_PERM;
		}
		else
		{
			$user = new User($db);
			
			if (!empty($userId)) {
				
				$applicationData = $user->getApplication($userId);			
				$userDatas = $user->getUserData($userId);
				$userData = $userDatas['user'];

				if ($applicationData['internal']['faculty_id'] != $logged_admin['faculty']['id'])
				{
					
				}
				else
				{
					$page->assign('APPLICATION_DATA', $applicationData['display']);
					$page->assign('USER_DATA', $userData['display']);
		
					$records = new Records($db);
					$records->assignUser($userData['internal']);
					
					switch ($action) {
						
						case 'save':
						
							if (!empty($_REQUEST['save'])) {
								if (!empty($_REQUEST['modificator_type'])) {
									$modificatorData = array(
										'type' => $_REQUEST['modificator_type'],
										'value' => $_REQUEST['modificator_count']
										);
								}
			
								$records->saveRecord($_REQUEST['entry_type'], $_REQUEST['comment'], $modificatorData, $recordId);
							}
							
							header('Location: '.$activeSection['url'].'&user_id='.$applicationData['display']['user_id']);
							exit();
							
						break;
						
						case 'edit':
							$recordData = $records->getRecord($recordId);
											
							$page->assign('RECORD', $recordData);
							$page->parse('main.students_additional_info.user_details.edit_form.record_id');
							
						case 'add':
						
							$recordTypes = $db->GetResults("SELECT * FROM tblRecordTypes WHERE faculty_id = '{$logged_admin['faculty']['id']}' ORDER BY priority_no");					
							foreach ($recordTypes as $recordType) {
								
								if ($recordType['record_type_tag'] == $recordData['record_type']) {
									$recordType['select'] = ' selected="selected"';
								}
								else {
									$recordType['select'] = '';
								}
								
								$page->assign('RECORD_TYPE', $recordType);
								$page->parse('main.students_additional_info.user_details.edit_form.record_type');
							}				
		
							$modificatorTypes = $db->GetResults("SELECT * FROM tblModificatorTypes WHERE faculty_id = '{$logged_admin['faculty']['id']}'");					
							foreach ($modificatorTypes as $modificatorType) {
								
								if ($modificatorType['modificator_type_id'] == $recordData['modificator_type']) {
									$modificatorType['select'] = ' selected="selected"';
								}
								else {
									$modificatorType['select'] = '';
								}
		
								$page->assign('MODIFICATOR', $modificatorType);
								$page->parse('main.students_additional_info.user_details.edit_form.modificator_type');
							}				
						
							$editForm['title'] = $action == 'edit' ? 'prava zznamu' : 'Nov zznam';
						
							$page->assign('EDIT_FORM', $editForm);
						
							$page->parse('main.students_additional_info.user_details.edit_form');
						break;
						
						case 'delete':
							$records->deleteRecord($recordId);
							header('Location: '.$activeSection['url'].'&user_id='.$applicationData['display']['user_id']);
							exit();
						break;
						
						case 'edit_application':
						
							if (!empty($_REQUEST['storno'])) {
								header('Location: admin.php?section='.$activeSection['section_id'].'&user_id='.$userId);
								exit();
							}
							
							if (!empty($_REQUEST['save_application'])) {
								$result = saveApplicationForm('edit');
								
								switch ($result) {
									case 'ERROR_ID':
										$userDatas['registration'] = $_REQUEST;
										$userDatas['user']['internal'] = $_REQUEST;
										$applicationData['internal'] = $_REQUEST;
										
										$page->assign('ERROR', 'Mus by zadan rodn slo alebo ISIC slo.');
										$page->parse('main.students_additional_info.user_details_edit.error');
									break;
									default:
										header('Location: admin.php?section='.$activeSection['section_id'].'&user_id='.$userId.'&saved=true');
										exit(2);
									break;
								}
							}
						
							$userFormData = $userData['internal'];
		
							$formUrl = '&amp;user_id='.$userId.'&amp;action=edit_application';
							showApplicationForm($page, $userDatas, $applicationData, $formUrl);
		
							$editForm['title'] = 'Upravi iados';
							$page->assign('EDIT_FORM', $editForm);
							
							$page->parse('main.students_additional_info.user_details_edit');					
		
						break;
						
						default:
						
							$history = new History($db, $userData['internal']['id_type']);
							$historyRecords = $history->getHistory($userData['internal']['id']);
						
							if (count($historyRecords)) {
								foreach ($historyRecords as $historyRecord) {
									
									$historyRecord['history_action'] = $history->translateHistoryActionToHuman($historyRecord['history_action']);
									$historyRecord['start_year'] = $historyRecord['start_year'].'/'.($historyRecord['start_year'] + 1);
									$historyRecord['end_year'] = $historyRecord['end_year'].'/'.($historyRecord['end_year'] + 1);
									$historyRecord['year_count'] = $historyRecord['end_year'] - $historyRecord['start_year'] + 1;
									
									$page->assign('HISTORY_RECORD', $historyRecord);
									$page->parse('main.students_additional_info.user_details.history.record');
								}
								$page->parse('main.students_additional_info.user_details.history');
							}
							
							$userRecords = $records->listRecords();
							
							if (count($userRecords)) {
								
								$modificators = new Modificators($db);			
								$modificators->assignUser($userData['internal']);
				
								foreach ($userRecords as $userRecord) {
									
									$userRecord['entry_type'] = $records->translateEntryTypeToHuman($userRecord['record_type']);
									
									if (!empty($userRecord['modificator_type'])) {
										$modificator = $modificators->getModificatorById($userRecord['modificator_type']);
										$userRecord['modificator_name'] = $modificator['name'];
									}
									
									$page->assign('RECORD', $userRecord);
									$page->parse('main.students_additional_info.user_details.records.records_list.record');
								}
								
								$page->parse('main.students_additional_info.user_details.records.records_list');
				
							}
							
							$page->parse('main.students_additional_info.user_details.records');
							
							$page->parse('main.students_additional_info.user_details.edit_application');			
					}
		
		
					if ($action != 'edit_application') {
						$page->parse('main.students_additional_info.user_details');
					}
				}
			}
			
			if ($action == 'add_application') {
				
				if (!empty($_REQUEST['storno'])) {
					header('Location: admin.php?section='.$activeSection['section_id']);
					exit();
				}
				
						if (!empty($_REQUEST['save_application'])) {
							$result = saveApplicationForm('new');
							
							switch ($result) {
								case 'ERROR_ID':
									$userDatas['registration'] = $_REQUEST;
									$userDatas['user']['internal'] = $_REQUEST;
									$applicationData['internal'] = $_REQUEST;
									
									$page->assign('ERROR', 'Mus by zadan rodn slo alebo ISIC slo.');
									$page->parse('main.students_additional_info.user_details_edit.error');
								break;
								default:
									header('Location: admin.php?section='.$activeSection['section_id'].'&user_id='.$userId.'&saved=true');
									exit(2);
								break;
							}
						}
			
				
				$editForm['title'] = 'Nov iados';
				$page->assign('EDIT_FORM', $editForm);
				
				$userDatas = $user->getUserDataForStudentId($studentId);
				$applicationData['internal'] = $userDatas['user']['internal'];
				$applicationData['internal']['sex'] = ($applicationData['internal']['sex'] == 1 ? 'male' : ($applicationData['internal']['sex'] == 2 ? 'female' : ''));
				$applicationData['internal']['year']++;
				
				$formUrl = '&amp;student_id='.$studentId.'&amp;action=add_application';
				showApplicationForm($page, $userDatas, $applicationData, $formUrl);
				
				$page->parse('main.students_additional_info.user_details_edit');		
			}
			
			if (empty($studentId)) {
				$applications = $db->GetResults("SELECT * FROM tblUserApplications WHERE faculty_id = '{$logged_admin['faculty']['id']}' ORDER BY surname");
				foreach ($applications as $application) {
					
					$application['select'] = ($application['user_id'] == $userId ? ' selected="selected"' : '');
					
					$page->assign('APPLICATION', $application);
					$page->parse('main.students_additional_info.show_application.user');
				}
				
				$page->parse('main.students_additional_info.show_application');						
			}
			
			if (empty($userId)) {
				$students = getStudentsWithoutApplication($logged_admin['faculty']['id']);
				
				foreach ($students as $student) {
					
					$student['select'] = ($student['student_id'] == $studentId ? ' selected="selected"' : '');
					
					$page->assign('STUDENT', $student);
					$page->parse('main.students_additional_info.add_application.student');
				}
				
				$page->parse('main.students_additional_info.add_application');
			}
			
			$page->parse('main.students_additional_info');
		}		
	break;
	
	case 'students_history_import':
	
		if (!empty($logged_admin['faculty']['id']))
		{
			if (!empty($_REQUEST['import'])) {
	
				$students = $db->GetResults("SELECT student_id FROM tblStudents WHERE faculty_id = '{$logged_admin['faculty']['id']}'");
				
				foreach ($students as $student)
				{
					$db->Query("DELETE FROM tblStudentHistory WHERE student_id = '{$student['student_id']}'");
				}
				
				$content = $_REQUEST['content'];
				if (get_magic_quotes_gpc()) {
				   $content = stripslashes($content);
				} 
				
				$contentArray = explode("\n", $content);
				$history = array();
				
				foreach ($contentArray as $contentArrayItem) {
					
					$temp = explode(',', $contentArrayItem);
					
					$studentId = trim($temp[0]);
					$studentHistory = trim($temp[1]);
					
					if (!empty($studentHistory)) {
						$studentId = substr($studentId, 1, strlen($studentId) - 2);
						$studentHistory = substr($studentHistory, 1, strlen($studentHistory) - 2);
						
						$history[$studentId]['parsed'] = parseHistory($studentHistory, $_REQUEST['last_year']);
						$history[$studentId]['unparsed'] = $studentHistory;
					}
				}
				
				foreach ($history as $studentId => $historyActions) {

					foreach ($historyActions['parsed'] as $historyAction) {
						
						$user_id = getStudentUserId($studentId);
						
						if (!empty($user_id))
						{
							$db->Query("
								INSERT INTO 
									tblStudentHistory 
								(
									student_id, 
									history_action, 
									start_year, 
									end_year
								)
								VALUES
								( 
									'".$studentId."', 
									'".$historyAction['history_action']."', 
									'".$historyAction['start_year']."', 
									'".$historyAction['end_year']."')");
						}
					}
				}
															
				$page->parse('main.students_history_import.result');
			}
			else {
				$page->parse('main.students_history_import.form');
			}
			
			$page->parse('main.students_history_import');
		}
		else
		{
			$section_error = ER_NO_FACULTY_PERM;
		}
	break;
	
	case 'place_owners':
	
		if (empty($logged_admin['dormitory']['id']))
		{
			$section_error = ER_NO_DORMITORY_PERM;
		}
		else
		{
			$selected_locality_id = $_GET["idLokalita"];
			$selected_block_id = $_GET["idBlok"];
			$selected_room_id = $_GET["idIzba"];
			$selected_room_ids = $_GET["idIzby"];
			$selected_place_ids = $_GET["idMiesta"];
			$selected_faculty_id = $_GET["idVlastnik"];
			$confirm = $_GET["confirm"];
			$selected_season_id = $active_season_id;
			
			$date = time();
			
			if(count($selected_place_ids) && $confirm == '1') {
				// pridel vlastnika na vybrate miesta
				foreach ($selected_place_ids as $idMiesto) {
					assignPlaceToFaculty($idMiesto, $selected_faculty_id, $date);
				}
				
			} else {
				if(count($selected_room_ids) && $confirm == '1' ) {
					
					// pridel vlastnika na cele izby 
					foreach ($selected_room_ids as $selected_room_id) {
						assignRoomToFaculty($selected_room_id, $selected_faculty_id, $date);
					}
				}
			}
			
			if ($selected_season_id) 
			{
	
				$localities = getLocalities($logged_admin['dormitory']['id']);
				
				foreach ($localities as $locality)
				{					
					if ($selected_locality_id == $locality["id"]) {
						$selected_locality = $locality;
						$locality['selected'] = ' selected="selected"';
					}
									
					$page->assign('LOCALITY', $locality);
					$page->parse('main.place_owners.localities.locality');
				}
	
				$page->parse('main.place_owners.localities');
				
				if (isset($selected_locality)) {			
					
					$blocks = getBlocks($selected_locality_id);
				
					foreach ($blocks as $block)
					{						
						if ($selected_block_id == $block["id"]) {
							$selected_block = $block;
							$block['selected'] = ' selected="selected"';
						}	
						
						$page->assign('BLOCK', $block);
						$page->parse('main.place_owners.blocks.block');
					}
	
					$page->parse('main.place_owners.blocks');
									
					if (isset($selected_block)) {
						
						$rv = $db->Query("SELECT * FROM tblFaculties");

						$faculties = getEntities('faculty');
						
						foreach ($faculties as $faculty)
						{		
							$faculty['selected'] = ($selected_faculty_id == $faculty["id"] ? ' selected="selected"' : '');				
							
							$page->assign('OWNER', $faculty);
							$page->parse('main.place_owners.owners.owner');
						}
						
						$page->parse('main.place_owners.owners');

						$rooms = getRooms($selected_block_id);
				
						foreach ($rooms as $room)
						{			
							$room['name'] = 
								$selected_locality["abbreviation"] . ' ' . 
								$selected_block["name"] . ' ' . 
								$room["number"] . ' (' . 
								$room["available_capacity"] . '/' . $room["capacity"] . 
								getRoomDescription($room['id']) . ' )';

							$page->assign('ROOM', $room);
							$page->parse('main.place_owners.rooms.room');
						}
											
						if($confirm == '2' && count($selected_room_ids) > 0 ) {
			
							foreach ($selected_room_ids as $selected_room_id) {

								$places = getPlaces($selected_room_id);
				
								foreach ($places as $place)
								{
									$place['name'] = 
										$selected_locality["abbreviation"] . ' ' . 
										$selected_block["name"] . ' ' . 
										$place["number"] . ' (' . 
										$place["season"] . 
										($place["abbreviation"] == '' ? '' : ' - ') . 
										$place["abbreviation"] . ')';
									
									$page->assign('PLACE', $place);
									$page->parse('main.place_owners.rooms.places.place');
								}
							}
							
							$page->parse('main.place_owners.rooms.places');
							$roomColspan = 1;
						}
						else {
							$roomColspan = 3;
						}
						
						$page->parse('main.place_owners.buttons');
						$page->parse('main.place_owners.rooms');
					}
				}
			}
		
			$page->assign('ROOM_COLSPAN', $roomColspan);
			$page->parse('main.place_owners');
		}
	break;
	
	case 'lines_definition':
		
		if (!empty($logged_admin['faculty']['id']))
		{
			if ($_POST['save']) {
				Properties::saveProperty('rating_for_line_present', $_POST['rating_for_line_present'], 'faculty', $logged_admin['faculty']['id']);
				Properties::saveProperty('rating_for_line_new', $_POST['rating_for_line_new'], 'faculty', $logged_admin['faculty']['id']);
			}

			$page->assign('PROPERTIES', Properties::retrieveProperties('faculty', $logged_admin['faculty']['id']));
			
			$page->parse('main.lines_definition');
		}
		else
		{
			$section_error = ER_NO_FACULTY_PERM;
		}
	break;

	case 'messages':
		if (!empty($logged_admin['faculty']['id']))
		{
			$action = $_REQUEST['action'];
			$message_id = $_REQUEST['message_id'];
			
			switch ($action)
			{
				case 'save':
					saveMessage();
					
					header('Location: admin.php?section='.$activeSection['section_id']);
					exit;
				break;
				
				case 'delete':
					deleteMessage($message_id);
					
					header('Location: admin.php?section='.$activeSection['section_id']);
					exit;
				break;				

				case 'edit':
					
					$raw_message = array();
					if (!empty($message_id))
					{
						$raw_message = getMessage($message_id);
					}
					
					foreach ($raw_message as $prop_tag => $prop_value)
					{
						$message[$prop_tag] = htmlspecialchars($prop_value);
					}
					
					if (empty($message['message_tag']))
					{
						$list_tags = getListTags($logged_admin['faculty']['id']);
						
						foreach ($list_tags as $list_tag)
						{
							$list_tag['selected'] = $message['list_tag'] == $list_tag['tag'] ? ' selected="selected"' : '';
							
							$page->assign('LIST_TAG', $list_tag);
							$page->parse('main.messages.edit.list_tags.item');
						}
						
						$page->parse('main.messages.edit.list_tags');
					}
					
					$message['publish_select'][$message['publish']] = ' selected="selected"';
					
					$page->assign('MESSAGE', $message);

					$page->parse('main.messages.edit');
				break;

				default:
					$messages = getMessages($logged_admin['faculty']['id']);
					
					foreach ($messages as $message)
					{
						$message['subject'] = htmlspecialchars($message['subject']);
						$message['class'] = empty($message['has_message_tag']) ? '' : 'special';
						
						$page->assign('MESSAGE', $message);
						
						if (empty($message['has_message_tag']))
						{
							$page->parse('main.messages.list.message.delete');
						}
						
						$page->parse('main.messages.list.message');
					}
					
					$page->parse('main.messages.list');
			}

			$page->parse('main.messages');
		}
		else
		{
			$section_error = ER_NO_FACULTY_PERM;
		}
	break;
	
	case 'places':
	
		if (!empty($logged_admin['faculty']['id']))
		{
			$realPlaces = array();
			$errorMessage = '';
		
			if ($_POST['add_list']) {
				addCustomList($_POST['list_name'], $logged_admin['faculty']['id']);
			}
	
			if ($_POST['delete_list']) 
			{
				deleteCustomList($_POST['list_id']);
			}
			
			if ($_GET['show'] == 'lists') {
				
				$lists = getCustomLists($logged_admin['faculty']['id']);

				foreach ($lists as $list) {
					$page->assign('LIST', $list);
					$page->parse('main.places.lists_shown.list');
				}
							
				$page->parse('main.places.lists_shown');
			}
			else {
				$page->parse('main.places.lists_hidden');
			}
				
			if (!empty($_POST['setfilter']) || !empty($_GET['set_list'])) {
				
				setSessionData();

				$activeFilter = getActiveFilter($_SESSION['filter_id']);
				
				if (!empty($activeFilter['sql_query'])) 
				{
					feedAplicationListCache($activeFilter);
				}
				else 
				{
					$_SESSION['filter_id'] = 0;
				}				
			}
					
			if (!empty($_REQUEST['setuser'])) {
				$_SESSION['a_user_id'] = $_REQUEST['user_id'];				
				$_SESSION['show_only_free_places'] = $_REQUEST['show_only_free_places'];
			}
					
			if (!empty($_REQUEST['set_user'])) {
				$_SESSION['a_user_id'] = $_REQUEST['set_user'];
			}			
					
			$activeFilterId = $_SESSION['filter_id'];
			$activeUserId = $_SESSION['a_user_id'];
			$workOnNew = ($_SESSION['new'] == 'T');
			$workOnPresent = ($_SESSION['present'] == 'T');
			$workOnApplicationsWithoutPlace = ($_SESSION['without_place'] == 'T');
			$showMales = ($_SESSION['male'] == 'T');
			$showFemales = ($_SESSION['female'] == 'T');
			$ordered = ($_SESSION['ordered'] == 'T');
			$show_only_free_places = ($_SESSION['show_only_free_places'] == 'T');
			
			$checked['new'] = ($workOnNew ? ' checked="checked"' : '');
			$checked['present'] = ($workOnPresent ? ' checked="checked"' : '');
			$checked['without_place'] = ($workOnApplicationsWithoutPlace ? ' checked="checked"' : '');
			$checked['male'] = ($showMales ? ' checked="checked"' : '');
			$checked['female'] = ($showFemales ? ' checked="checked"' : '');
			$checked['ordered'] = ($ordered ? ' checked="checked"' : '');
			$checked['show_only_free_places'] = ($show_only_free_places ? ' checked="checked"' : '');
			
			$page->assign('CHECKED', $checked);
		
			if (!empty($activeUserId)) {
	
				if (!empty($_GET['add_to_list'])) {
					$db->Query("INSERT INTO tblApplicationsInCustomLists VALUES ('".$_GET['add_to_list']."', '".$activeUserId."')");
					
					if ($activeFilterId == 'custom_'.$_GET['add_to_list']) {
						$db->Query("INSERT INTO tblApplicationsList VALUES (NULL, '".$activeUserId."', '{$logged_admin['faculty']['id']}')");
					}
				}
	
				if (!empty($_GET['remove_from_list'])) {
					$db->Query("DELETE FROM tblApplicationsInCustomLists WHERE list_id='".$_GET['remove_from_list']."' AND user_id='".$activeUserId."'");
	
					if ($activeFilterId == 'custom_'.$_GET['remove_from_list']) {
						$db->Query("DELETE FROM tblApplicationsList WHERE user_id='".$activeUserId."' AND faculty_id = '{$logged_admin['faculty']['id']}'");
					}
				}
			}		
			
			$filters = $db->GetResults("SELECT filter_id, name FROM tblApplicationsListFilters ORDER BY order_no");
			
			foreach ($filters as $filter) {
				
				if ($activeFilterId == $filter['filter_id']) {
					$filter['selected'] = ' selected="selected"';
				}
				else {
					$filter['selected'] = '';
				}
				
				$page->assign('FILTER', $filter);
				$page->parse('main.places.filter');			
			}
	
			$customFilters = getCustomLists($logged_admin['faculty']['id']);
			
			foreach ($customFilters as $customFilter) {
				
				$customFilter['filter_id'] = 'custom_'.$customFilter['list_id'];
				$customFilter['name'] = 'Zoznam: '.$customFilter['name'];
	
				if ($activeFilterId == 'custom_'.$customFilter['list_id']) {
					$customFilter['selected'] = ' selected="selected"';
				}
				else {
					$customFilter['selected'] = '';
				}
				
				$page->assign('FILTER', $customFilter);
				$page->parse('main.places.filter');			
			}
		
			if (!empty($activeFilterId)) {
				
				$conditions = $condition = array();
				if ($workOnNew) {
					$conditions[1][] = ' s.student_type = \'new\'';
				}
	
				if ($workOnPresent) {
					$conditions[1][] = ' s.student_type = \'present\'';
				}
				
				if ($workOnApplicationsWithoutPlace) {
					$conditions[2][] = ' ar.user_id IS NULL';
				}
	
				if ($showMales) {
					$conditions[3][] = ' a.sex = \'male\'';
				}
	
				if ($showFemales) {
					$conditions[3][] = ' a.sex = \'female\'';
				}
				
				foreach ($conditions as $conditionPart) {
					if (count($conditionPart)) {
						$condition[] = '('.implode(' OR ', $conditionPart).')';
					}
				}
				
				if (count($condition)) {
					$sqlCondition = ' WHERE '.implode(' AND ', $condition);
				}
				else {
					//$sqlCondition = ' WHERE 1=0';
				}
				
				if (!empty($activeUserId) && !empty($_POST['setplace'])) {
					
					$placeId = $_POST['place_id'];
					$roomInfo = $db->Quick_fetch("SELECT user_id FROM tblAssignedPlaces WHERE place_id='".$placeId."' AND season_id = '$active_season_id'");
					
					if (empty($roomInfo['user_id']) || $roomInfo['user_id'] == $activeUserId) {
	
						$userInfo = $db->Quick_fetch("SELECT user_id FROM tblAssignedPlaces WHERE user_id='".$activeUserId."' AND season_id = '$active_season_id'");
						
						if (empty($userInfo['user_id'])) {					
							$db->Query("UPDATE tblAssignedPlaces SET user_id = '".$activeUserId."', note='".$_POST['note']."' WHERE place_id = '".$placeId."' AND season_id = '$active_season_id'");
						}
						else {
							$errorMessage = 'ER_USER_HAS_ASSIGNED_PLACE';
						}
					}
					else {
						$errorMessage = 'ER_PLACE_HAS_ASSIGNED_USER';
					}
				}			
	
				if (!empty($_POST['clearplace'])) {
					$placeId = $_POST['place_id'];					
					$db->Query("UPDATE tblAssignedPlaces SET user_id = '0' WHERE place_id = ".$placeId);						
				}
				
				$applications = $db->GetResults("
					SELECT
						al.order_no, 
						a.*, 
						ar.place_id as assignation_id
					FROM
						tblUserApplications AS a
					INNER JOIN
						tblApplicationsList AS al
						ON a.user_id = al.user_id
							AND
						al.faculty_id = '{$logged_admin['faculty']['id']}'
					INNER JOIN
						tblStudents AS s
						ON a.student_id = s.student_id
					LEFT JOIN
						tblAssignedPlaces AS ar
						ON a.user_id = ar.user_id
					".$sqlCondition."
					GROUP BY a.user_id			
					ORDER BY
						".($ordered ? 'al.order_no' : 'a.surname')."
				");
				
				$ac = 0;
				$userSelected = false;
				$next = (!empty($_GET['next']) ? $_GET['next'] : 0);
				$previous = (!empty($_GET['previous']) ? $_GET['previous'] : 0);
				$storeNext = false;
				
				foreach ($applications as $application) {
	
					if ($storeNext) {
						$next = $application['user_id'];
						$storeNext = false;
					}
					
					$ac++;
					if ($activeUserId == $application['user_id']) {
						$application['selected'] = ' selected="selected"';
						$userSelected = true;
						$previous = $tempPrevious;
						$storeNext = true;
					}
					else {
						$application['selected'] = '';
					}
					
					$tempPrevious = $application['user_id'];
	
					$page->assign('APPLICATION', $application);
					$page->parse('main.places.applications.application');			
				}
							
				$page->assign('APPLICATIONS_COUNT', $ac);
										
				// USER IS SELETED
				if (!empty($activeUserId)) {
					
					$user = new User($db);
					
					$applicationData = $user->getApplication($activeUserId);
					$registrationData = $user->getRegistrationData($activeUserId);
					
					$assignedPlace = $user->getAssignedUserPlace($activeUserId);
					
					$selectedAssignedId = (!empty($_POST['list_id']) ? $_POST['list_id'] : $assignedPlace['id']);
					
					if (count($assignedPlace)) {
						$applicationData['display']['assigned_room'] = $assignedPlace['location'] . $assignedPlace['block'].' '.$assignedPlace['room'];
					}
	
					if (!$userSelected) {
						$application = $applicationData['display'];
						$application['selected'] = ' selected="selected"';
						$application['name'] .= ' (mimo vberu)';
						$page->assign('APPLICATION', $application);
						$page->parse('main.places.applications.application');
					}
	
					if (!empty($previous)) {
						$page->assign('NAV_PREVIOUS', $previous);
						$page->parse('main.places.applications.previous');
					}
	
					if (!empty($next)) {
						$page->assign('NAV_NEXT', $next);
						$page->parse('main.places.applications.next');
					}
	
					print_r($navigation);
	
					$page->assign('APPLICATION', $applicationData['display']);
					
					$places = $db->GetResults("SELECT * FROM tblUserPlaces WHERE user_id='".$activeUserId."' ORDER BY order_no");
					
					$placesAdded = array();
					foreach ($places as $place) {
						$place['human_name'] = getHumanNameOfThePlace($place['place_id']);
											
						if ($place['flag'] == 'last_year') {
							$place['human_name'] .= ' (minul rok)';
						}
						
						$page->assign('PLACE', $place);
						
						if (!empty($place['location']) && !empty($place['block']) && !empty($place['room'])) {
							if (empty($placesAdded[$place['location']][$place['block']][$place['room']])) {
								$realPlaces[] = $place;
								$placesAdded[$place['location']][$place['block']][$place['room']] = true;
							}
						}
						
						$page->parse('main.places.applications.user.place');
					}
					
					$lists = getUserCustomLists($activeUserId, $logged_admin['faculty']['id']);
					
					foreach ($lists as $list) {
						
						$page->assign('LIST', $list);
						
						if (empty($list['inlist'])) {
							$page->parse('main.places.applications.user.list.add');
						}
						else {
							$page->parse('main.places.applications.user.list.remove');
						}
						
						$page->parse('main.places.applications.user.list');
					}				
				
					$friends = $db->GetResults("
						SELECT
							u.user_id, f.description
						FROM
							tblUserFriends as f
						INNER JOIN 
							tblUsers as u
							ON f.login = u.login
						WHERE f.user_id='".$activeUserId."'");
					
					foreach ($friends as $friend) {
						
						$friendApplicationData = $user->getApplication($friend['user_id']);
						
						$mutualUser = $db->Quick_fetch("SELECT friend_id FROM tblUserFriends WHERE login='".$registrationData['login']."' AND user_id='".$friend['user_id']."'");
											
						$places = $db->GetResults("SELECT * FROM tblUserPlaces WHERE user_id='".$friend['user_id']."' ORDER BY order_no");
	
						if (!empty($mutualUser['friend_id'])) {
							$page->parse('main.places.applications.user.friend.mutual');
						}
						
						foreach ($places as $place) {
		
							$place['human_name'] = getHumanNameOfThePlace($place['place_id']);
							
							if ($place['flag'] == 'last_year') {
								$place['human_name'] .= ' (minul rok)';
							}
	
							$page->assign('FRIEND_PLACE', $place);
							$page->parse('main.places.applications.user.friend.place');
						}						
	
						$friendAssignedPlace = $user->getAssignedUserPlace($friend['user_id']);
						
						if (count($friendAssignedPlace)) {
							$friendApplicationData['display']['assigned_room'] = $friendAssignedPlace['location'] . $friendAssignedPlace['block'].' '.$friendAssignedPlace['room'];
						}
						
						$page->assign('FRIEND_APPLICATION', $friendApplicationData['display']);
						$page->assign('FRIEND_DESCRIPTION', $friend['description']);
						$page->parse('main.places.applications.user.friend');
	
					}
					
					// ludia, ktori uviedli daneho ziadatela ako kamarata
					
					$friends = $db->GetResults("
						SELECT
							f.user_id, f.description
						FROM
							tblUserFriends as f
						WHERE f.login='".$registrationData['login']."'");
					
					foreach ($friends as $friend) {
						
						$friendApplicationData = $user->getApplication($friend['user_id']);
						$friendRegistrationData = $user->getRegistrationData($friend['user_id']);
						
						$mutualUser = $db->Quick_fetch("SELECT friend_id FROM tblUserFriends WHERE login='".$friendRegistrationData['login']."' AND user_id='".$registrationData['user_id']."'");
											
						$places = $db->GetResults("SELECT * FROM tblUserPlaces WHERE user_id='".$friend['user_id']."' ORDER BY order_no");
	
						if (!empty($mutualUser['friend_id'])) {
							$page->parse('main.places.applications.user.friend_for.mutual');
						}
						
						foreach ($places as $place) {
		
							$place['human_name'] = getHumanNameOfThePlace($place['place_id']);
							
							if ($place['flag'] == 'last_year') {
								$place['human_name'] .= ' (minul rok)';
							}
	
							$page->assign('FRIEND_PLACE', $place);
							$page->parse('main.places.applications.user.friend_for.place');
						}						
	
						$friendAssignedPlace = $user->getAssignedUserPlace($friend['user_id']);
						
						if (count($friendAssignedPlace)) {
							$friendApplicationData['display']['assigned_room'] = $friendAssignedPlace['location'] . $friendAssignedPlace['block'].' '.$friendAssignedPlace['room'];
						}
						
						$page->assign('FRIEND_APPLICATION', $friendApplicationData['display']);
						$page->assign('FRIEND_DESCRIPTION', $friend['description']);
						$page->parse('main.places.applications.user.friend_for');
	
					}
					
					foreach ($realPlaces as $realPlace) {
						$sameRooms = $db->GetResults("
							SELECT
								DISTINCT *
							FROM
								tblUserPlaces
							WHERE
								location = '".$realPlace['location']."'
								AND
								block = '".$realPlace['block']."'
								AND
								room = '".$realPlace['room']."'
								AND
								user_id <> '".$activeUserId."'
								");
						
						if (count($sameRooms)) {
							$realPlace['human_name'] = getHumanNameOfThePlace($realPlace['place_id'], array(), true);
							
							$page->assign('SAME_PLACE', $realPlace);
							
							foreach ($sameRooms as $sameRoom) {
								
								$sameUserData = $user->getApplication($sameRoom['user_id']);										
								$sameRoom['user_name'] = $sameUserData['display']['name'].' '.$sameUserData['display']['surname'];
								$sameRoom['student_id'] = $sameUserData['internal']['student_id'];
								
								$page->assign('SAME_USER', $sameRoom);
								$page->parse('main.places.applications.user.same_place.same_user');
							}
							
						}
						
						$page->parse('main.places.applications.user.same_place');
					}				
				
					$page->parse('main.places.applications.user');
				}

				$places = getPlacesList($show_only_free_places);
				
				$tempPlaces = array();
				foreach ($realPlaces as $realPlace) {
					$tempPlace = getPlacesList($show_only_free_places, $realPlace['room'], $realPlace['block'], $realPlace['location']);
					
					if (count($tempPlace)) {
						$tempPlaces = array_merge($tempPlaces, $tempPlace);
					}
				}
				
				if (count($tempPlaces)) {
					$line['room'] = '---------------------';
					$line['id'] = '000';
					
					$tempPlaces[] = $line;
				}
				
				$places = array_merge($tempPlaces, $places);

				foreach ($places as $place) {
					
					if ($selectedAssignedId == $place['id']) {
						$place['selected'] = ' selected="selected"';
						
						$page->assign('ACTIVE_PLACE_NOTE', $place['note']);
					}
					else {
						$place['selected'] = '';
					}
									
					$page->assign('PLACE', $place);
					$page->parse('main.places.applications.place');
				}
					
				if (!empty($activeUserId) && $applicationData['display']['status_code'] == 'successful') {
					$page->parse('main.places.applications.assign_button');
				}
					
				if (!empty($errorMessage)) {
					$page->parse('main.places.applications.error.'.$errorMessage);
					$page->parse('main.places.applications.error');
				}
				
				$page->parse('main.places.applications');
				
			}
			
			$page->parse('main.places');
		}
		else
		{
			$section_error = ER_NO_FACULTY_PERM;
		}			
	break;

	case 'generate_xls':
	
		if (!empty($logged_admin['faculty']['id']))
		{
			
			$faculty = $db->GetResult("SELECT * FROM tblFaculties WHERE id = '{$logged_admin['faculty']['id']}' ");
			$season = $db->GetResult("SELECT * FROM tblSeasons WHERE id = '$active_season_id' ");
			$season['http_name'] = str_replace('/', '-', $season['name']);
			
			switch ($_GET['list']) {
		
				case 'rooms':
	
					$miesta = $db->GetResults("
						SELECT
							l.abbreviation,
							i.number,
							l.abbreviation, b.name, i.number,
							a.surname AS priezvisko,
							a.name AS meno,
							a.year AS rocnik,
							s.name AS odbor,
							a.address,
							a.psc,
							a.city
						FROM
							tblPlaces AS p							
						INNER JOIN
							tblRooms as i	
							ON
								p.room_id = i.id
						INNER JOIN
							tblBlocks as b
							ON
							i.block_id = b.id
						INNER JOIN
							tblLocalities as l
							ON
							b.locality_id = l.id
						LEFT JOIN
							tblAssignedPlaces as ar
						ON
							p.place_id = ar.place_id
						LEFT JOIN
							tblUserApplications as a
							ON
							ar.user_id = a.user_id
						LEFT JOIN
							tblStudySections as s
							ON a.section = s.section_id
						WHERE
							ar.faculty_id = '{$logged_admin['faculty']['id']}'
								AND
							ar.season_id = '$active_season_id'
						ORDER BY
							l.abbreviation, b.name, i.number");
					
					
					$p = 0;
					$assignedCount = 0;
						
					// Create an instance
					$xls =& new Spreadsheet_Excel_Writer();	
				
					// Send HTTP headers to tell the browser what's coming
					$xls->send($faculty['abbreviation'] . "-rozdelenie-izieb-" . $season['http_name'] . ".xls");
					
					// Add a worksheet to the file, returning an object to add data to
					$sheet =& $xls->addWorksheet($faculty['abbreviation'] . ' ' . $season['http_name']);
					$f = 3;
					
					
					$sheet->setColumn(0, 2, 4);
					$sheet->setColumn(3, 3, 15);
					$sheet->setColumn(4, 4, 11);
					$sheet->setColumn(5, 5, 5);
					$sheet->setColumn(6, 6, 5);
					$sheet->setColumn(7, 7, 9);
					$sheet->setColumn(8, 8, 25);
					$sheet->setColumn(9, 9, 6);
					$sheet->setColumn(10, 10, 27);
					
					$sheet->setLandscape();
						
					$format_heading =& $xls->addFormat();
					$format_heading->setSize(14);
					$format_heading->setHAlign('center');
					$format_heading->setBold();
					$format_heading->setBorderColor('silver');
					$format_heading->setBorder(1);
					
					$format_place =& $xls->addFormat();
					$format_place->setHAlign('center');
					$format_place->setSize(10);
					$format_place->setBorderColor('silver');
					$format_place->setBorder(1);
				
					$format_data =& $xls->addFormat();
					$format_data->setHAlign('left');
					$format_data->setSize(10);
					$format_data->setBorderColor('silver');
					$format_data->setBorder(1);
				
					$format_title =& $xls->addFormat();
					$format_title->setHAlign('center');
					$format_title->setSize(8);
					$format_title->setBorderColor('silver');
					$format_title->setBorder(1);
					
					$sheet->writeString(0, 0, 'Rozdelenie miest pre tudentov a doktorandov ' . $faculty['abbreviation'] . ' na akademick rok ' . $season['name'], $format_heading);
					$sheet->mergeCells(0, 0, 0, 10);
							
					$sheet->write(2, 0, 'Objekt', $format_title);
					$sheet->write(2, 1, 'Blok', $format_title);
					$sheet->write(2, 2, 'Izba', $format_title);
					$sheet->write(2, 3, 'Priezvisko', $format_title);
					$sheet->write(2, 4, 'Meno', $format_title);
					$sheet->write(2, 5, 'Fakulta', $format_title);
					$sheet->write(2, 6, 'Ronk', $format_title);
					$sheet->write(2, 7, 'Odbor', $format_title);
					$sheet->write(2, 8, 'Ulica', $format_title);
					$sheet->write(2, 9, 'PS', $format_title);
					$sheet->write(2, 10, 'Mesto', $format_title);
					
					
					foreach ($miesta as $miesto) {

						 $sheet->writeString($f,0,$miesto['abbreviation'], $format_place);
						 $sheet->writeString($f,1,$miesto['name'], $format_place);
						 $sheet->writeString($f,2,$miesto['number'], $format_place);
						 $sheet->writeString($f,3,$miesto['priezvisko'], $format_data);
						 $sheet->writeString($f,4,$miesto['meno'], $format_data);
						 $sheet->writeString($f,5,$faculty['abbreviation'], $format_place);
						 $sheet->writeString($f,6,$miesto['rocnik'], $format_place);
						 $sheet->writeString($f,7,$miesto['odbor'], $format_data);
						 $sheet->writeString($f,8,$miesto['address'], $format_data);
						 $sheet->writeString($f,9,$miesto['psc'], $format_data);
						 $sheet->writeString($f,10,$miesto['city'], $format_data);
						 $f++;
						
					}
						
					// Finish the spreadsheet, dumping it to the browser
					$xls->close();
				break;
				
				case 'present':
				case 'new':

					$type = $_GET['list'];
					
					switch ($type)
					{
						case 'present':
							$title = 'Poradovnk sasnch tudentov a doktorandov ' . $faculty['abbreviation'] . ' na akademick rok ' . $season['name'];
							$filename = 'fmfi-poradovnik-sucasni-' . $season['http_name'] . '.xls';
						break;

						case 'new':
							$title = 'Poradovnk novoprijatch tudentov a doktorandov ' . $faculty['abbreviation'] . ' na akademick rok ' . $season['name'];
							$filename = 'fmfi-poradovnik-novoprijati-' . $season['http_name'] . '.xls';
						break;
					}
					
					$applications = getApplicationList($type);
				
					// spracuje zoznam ziadosti podla modifikatorov a vzorca
					$ziadatelia = generateApplicationOrder($applications, $type);
				
					$lineDrawn = false;
					$ratingForLine = Properties::getProperty('rating_for_line_' . $type, 'faculty', $logged_admin['faculty']['id']);	
					
					// Create an instance
					$xls =& new Spreadsheet_Excel_Writer();	
				
					// Send HTTP headers to tell the browser what's coming
					$xls->send($filename);
					
					// Add a worksheet to the file, returning an object to add data to
					$sheet =& $xls->addWorksheet($faculty['abbreviation'] . ' ' . $season['http_name']);
					$f = 3;
					
					
					$sheet->setColumn(0, 3, 4);
					$sheet->setColumn(4, 4, 15);
					$sheet->setColumn(5, 5, 11);
					$sheet->setColumn(6, 6, 5);
					$sheet->setColumn(7, 7, 5);
					$sheet->setColumn(8, 8, 9);
					$sheet->setColumn(9, 9, 25);
					$sheet->setColumn(10, 10, 6);
					$sheet->setColumn(11, 11, 27);
					
					$sheet->setLandscape();
						
					$format_heading =& $xls->addFormat();
					$format_heading->setSize(14);
					$format_heading->setHAlign('center');
					$format_heading->setBold();
					$format_heading->setBorderColor('silver');
					$format_heading->setBorder(1);
					
					$format_place =& $xls->addFormat();
					$format_place->setHAlign('center');
					$format_place->setSize(10);
					$format_place->setBorderColor('silver');
					$format_place->setBorder(1);
				
					$format_data =& $xls->addFormat();
					$format_data->setHAlign('left');
					$format_data->setSize(10);
					$format_data->setBorderColor('silver');
					$format_data->setBorder(1);
				
					$format_title =& $xls->addFormat();
					$format_title->setHAlign('center');
					$format_title->setSize(8);
					$format_title->setBorderColor('silver');
					$format_title->setBorder(1);
					
					$format_line =& $xls->addFormat();
					$format_line->setTopColor('black');
					$format_line->setTop('5');
					
					$sheet->writeString(0, 0, $title, $format_heading);
					$sheet->mergeCells(0, 0, 0, 11);
							
					$sheet->write(2, 0, '#', $format_title);
					$sheet->write(2, 1, 'Objekt', $format_title);
					$sheet->write(2, 2, 'Blok', $format_title);
					$sheet->write(2, 3, 'Izba', $format_title);
					$sheet->write(2, 4, 'Priezvisko', $format_title);
					$sheet->write(2, 5, 'Meno', $format_title);
					$sheet->write(2, 6, 'Fakulta', $format_title);
					$sheet->write(2, 7, 'Ronk', $format_title);
					$sheet->write(2, 8, 'Odbor', $format_title);
					$sheet->write(2, 9, 'Ulica', $format_title);
					$sheet->write(2, 10, 'PS', $format_title);
					$sheet->write(2, 11, 'Mesto', $format_title);
					
					$g = 1;
					$lineDrawn = false;
					foreach ($ziadatelia['ordering'] as $itemNo) {
				
						$miesto = $ziadatelia['applications_list'][$itemNo];
						
						if ($miesto['faculty_id'] != $logged_admin['faculty']['id'])
						{
							continue;
						}
						
						if (isUnderLine($miesto, $ratingForLine) && !$lineDrawn) {
							
							$sheet->writeString($f,0,'');
							$sheet->mergeCells($f, 0, $f, 11);
							$f++;
							
							$lineDrawn = true;
						}						
						
						$sheet->writeString($f,0,$g, $format_place);
						$sheet->writeString($f,1,$miesto['abbreviation'], $format_place);
						$sheet->writeString($f,2,$miesto['block_name'], $format_place);
						$sheet->writeString($f,3,$miesto['number'], $format_place);
						$sheet->writeString($f,4,$miesto['surname'], $format_data);
						$sheet->writeString($f,5,$miesto['name'], $format_data);
						$sheet->writeString($f,6,$faculty['abbreviation'], $format_place);
						$sheet->writeString($f,7,$miesto['year'], $format_place);
						$sheet->writeString($f,8,$miesto['section'], $format_data);
						$sheet->writeString($f,9,$miesto['address'], $format_data);
						$sheet->writeString($f,10,$miesto['psc'], $format_data);
						$sheet->writeString($f,11,$miesto['city'], $format_data);
						
						$f++;
						$g++;
						
					}
						
					// Finish the spreadsheet, dumping it to the browser
					$xls->close();	
				break;				
				default:
					$page->parse('main.excel_reports');			
			}
		}
		else
		{
			$section_error = ER_NO_FACULTY_PERM;
		}			
	
	break;
	
	case 'applications_decision':
		
		if (!empty($logged_admin['faculty']['id']))
		{
			$types = array('present' => 'present', 'new' => 'new');
			$type = $types[$_GET['type']];
			
			$action = $_GET['action'];
			
			switch ($action) {
				case 'set_group':
					$applications = getApplicationList($type.'_undecided');
					$orderedApplications = generateApplicationOrder($applications, $type);
						
					$ratingForLine = Properties::getProperty('rating_for_line_'.$type, 'faculty', $logged_admin['faculty']['id']);
					
					$successfulCount = $unsuccessfulCount = 0;
					$status = 'undecided';
					
					foreach ($orderedApplications['ordering'] as $itemNo) {
	
						$application = $orderedApplications['applications_list'][$itemNo];
						
						if ($application['faculty_id'] != $logged_admin['faculty']['id'])
						{
							continue;
						}

						if (!isUnderLine($application, $ratingForLine) && $status != 'unsuccessful') {
							$status = 'successful';
							$successfulCount++;
							$db->Query("UPDATE tblUserApplications SET status='".$status."' WHERE student_id='".$application['student_id']."'");
						}
						else {
							$status = 'unsuccessful';
							$unsuccessfulCount++;
						}
						
					}
					
					header('Location: admin.php?section='.$activeSection['section_id'].'&type='.$type.'&action=info&s='.$successfulCount.'&u='.$unsuccessfulCount);
					exit(2);
					
				break;
				
				case 'info':
					$counts['successful'] = $_GET['s'];
					$counts['unsuccessful'] = $_GET['u'];
					
					$page->assign('COUNTS', $counts);
					$page->parse('main.applications_decision.menu.info_'.$type);
					$page->parse('main.applications_decision.menu');
				break;
				
				case 'list':
					
					$applications = getApplicationList($type);
					$orderedApplications = generateApplicationOrder($applications, $type);
						
					$f = 0;
					
					$statuses = array(
						'undecided' => 'NEPOSDEN',
						'successful' => 'SPEN',
						'unsuccessful' => 'NESPEN'
					);
					
					$page->assign('TYPE', $type);
					
					foreach ($orderedApplications['ordering'] as $itemNo) {
						
						$application = $orderedApplications['applications_list'][$itemNo];
						
						if ($application['faculty_id'] != $logged_admin['faculty']['id'])
						{
							continue;
						}
												
						$application['no'] = ++$f;
						
						$application['status'] = $statuses[$application['status']];
						
						$page->assign('APPLICATION', $application);
						$page->parse('main.applications_decision.list.application');
					}
					
					$page->parse('main.applications_decision.list');
				break;
				
				case 'set':
					$db->Query("UPDATE tblUserApplications SET status='".$_GET['set']."' WHERE user_id='".$_GET['user_id']."'");
					
					header('Location: admin.php?section='.$activeSection['section_id'].'&type='.$type.'&action=list');
					exit();
				break;
				
				default:
					$page->parse('main.applications_decision.menu');
				break;
			}
			
			$page->parse('main.applications_decision');
		}
		else
		{
			$section_error = ER_NO_FACULTY_PERM;
		}
	break;
	
	case 'administrators':
		$action = $_GET['action'];
		$edited_admin_id = $_GET['admin_id'];
		
		$admin = getAdminDetails($edited_admin_id);		
		$page->assign('ADMIN', $admin);
		
		switch ($action) 
		{
			case 'add':
				$error_messages = array();

				if (isset($_REQUEST['add']))
				{
					if (empty($_REQUEST['login']))
					{
						$error_messages[] = 'Prihlasovacie meno neme by przdne.';
					}
					
					if (isAdminLoginExists($_REQUEST['login']))
					{
						$error_messages[] = 'Zadan prihlasovacie meno je u obsaden.';
					}

					if (empty($_REQUEST['pass']) || $_REQUEST['pass'] != $_REQUEST['verify_pass'])
					{
						$error_messages[] = 'Zadan hesl nie s rovnak alebo s przdne.';
					}
										
					if (count($error_messages) > 0)
					{
						$page->assign('SUBMITED_DATA', array('login' => $_REQUEST['login']));

						$page->assign('ERROR_MESSAGE', implode('<br />', $error_messages));
						$page->parse('main.administrators.add.error');
					}
					else
					{
						createNewAdmin($_REQUEST['login'], $_REQUEST['pass']);

						header('Location: admin.php?section='.$activeSection['section_id']);
						exit();
					}
				}
				
				$page->parse('main.administrators.add');
			break;

			case 'change_password':
				$is_error = false;

				if (isset($_REQUEST['change_password']))
				{
					if (!empty($_REQUEST['pass']) && $_REQUEST['pass'] == $_REQUEST['verify_pass'])
					{
						updateAdminPassword($edited_admin_id, $_REQUEST['pass']);

						header('Location: admin.php?section='.$activeSection['section_id']);
						exit();
					}
					else
					{
						$is_error = true;
					}
				}

				if ($is_error)
				{
					$page->parse('main.administrators.change_password.error');
				}
				
				$page->parse('main.administrators.change_password');
			break;

			case 'permissions':
				
				if (isset($_REQUEST['permissions']))
				{
					updateAdminPermissions($edited_admin_id, $_REQUEST['section_perm'], $_REQUEST['faculty_perm'], $_REQUEST['dormitory_perm']);

					header('Location: admin.php?section='.$activeSection['section_id']);
					exit();
				}
				
				$sections_perms = getSections($edited_admin_id);
				
				foreach ($sections_perms as $section_perm)
				{
					if (!empty($section_perm['has_perm']))
					{
						$section_perm['checked'] = ' checked="checked"';
					}

					$page->assign('SECTION_PERM', $section_perm);
					$page->parse('main.administrators.permissions.section_perm');
				}
						
				$faculties = getEntities('faculty', $edited_admin_id);
				
				foreach ($faculties as $faculty)
				{
					if (!empty($faculty['has_perm']))
					{
						$faculty['selected'] = ' selected="selected"';
					}

					$page->assign('FACULTY', $faculty);
					$page->parse('main.administrators.permissions.faculty');
				}

				$dormitories = getEntities('dormitory', $edited_admin_id);
				
				foreach ($dormitories as $dormitory)
				{
					if (!empty($dormitory['has_perm']))
					{
						$dormitory['selected'] = ' selected="selected"';
					}

					$page->assign('DORMITORY', $dormitory);
					$page->parse('main.administrators.permissions.dormitory');
				}				
				
				$page->parse('main.administrators.permissions');
			break;

			case 'delete':
				deleteAdmin($edited_admin_id);

				header('Location: admin.php?section='.$activeSection['section_id']);
				exit();
			break;

			default:
			case 'list':
				$admins_list = getAdminsList();
				
				if (count($admins_list) > 0)
				{
					foreach ($admins_list as $admin)
					{
						$page->assign('ADMIN', $admin);
						
						if (empty($admin['is_superadmin']))
						{
							$page->parse('main.administrators.list.admin.delete_command');
						}

						$page->parse('main.administrators.list.admin');
					}
	
					$page->parse('main.administrators.list');
				}
			break;
		}
		
		$page->parse('main.administrators');
	break;
	break;

	case 'settings':
		
		if (!empty($logged_admin['faculty']['id']))
		{
			if ($_POST['save']) {
				
				$properties_tags = array(
					'show_registration_panel_present',
					'show_registration_panel_new',
					'show_login_panel',
					'supress_registration_panel_present',
					'supress_registration_panel_new',
					'supress_login_panel',
					'allow_edit_application',
					'allow_edit_places',
					'allow_edit_friends'
				);
				
				foreach ($properties_tags as $property_tag)
				{
					Properties::saveProperty($property_tag, $_REQUEST[$property_tag], 'faculty', $logged_admin['faculty']['id']);
				}
			}
			
			$properties = Properties::retrieveProperties('faculty', $logged_admin['faculty']['id']);
			
			foreach ($properties as $propertyTag => $propertyValue) {
				$selectedValues[$propertyTag][$propertyValue] = ' selected="selected"';
			}
			
			$page->assign('PROPERTIES', $properties);
			$page->assign('SELECT', $selectedValues);
			
			$page->parse('main.settings');
		}
		else
		{
			$section_error = ER_NO_FACULTY_PERM;
		}
	break;
	
	case 'index':
	default:
		$page->parse('main.index');	
}

if (!empty($section_error))
{
	switch ($section_error)
	{
		case ER_NO_DORMITORY_PERM:
			$section_error_message = 'Nemte povolen prstup k iadnemu interntu.';
		break;
		
		case ER_NO_FACULTY_PERM:
			$section_error_message = 'Nemte povolen prstup k iadnej fakulte.';
		break;
		break;
		
		case ER_TECHNICAL_CONFIG_NEEDED:
			$section_error_message = 'Tto innos mus by nakonfigurovan technickm administrtorom.';
		break;
	}
	
	$page->assign('ERROR', $section_error_message);
	$page->parse('main.error');
}

#############################################################################
## show menu panels #########################################################
#############################################################################

if ($logged) {
	
	$page->assign('LOGGED_ADMIN', $logged_admin);
	$page->assign('GLOBAL_PROPERTIES', $global_properties);
	
	if (!empty($logged_admin['faculty']['abbreviation']))
	{
		$page->parse('main.user.faculty');
	}
	
	if (!empty($logged_admin['dormitory']['abbreviation']))
	{
		$page->parse('main.user.dormitory');
	}
	
	$sections = $db->GetResults('SELECT * FROM tblSections ORDER BY order_no');

	foreach ($sections as $section) {
		if (hasAdminRightToSection($admin_id, $section['section_id'])) {
			$page->assign('SECTION', $section);
			$page->parse('main.admin.section_link');
		}
	}
	
	$page->parse('main.admin');
}

foreach ($menuPanels as $menuPanel) {
	$page->parse('main.'.$menuPanel);
}

//$page->parse('main.message');
$page->parse('main');
$page->out('main');

?>