<?php

class Config
{
	var $modificators_class = '';
	var $records_class = '';
	var $rating_class = '';

	var $generic_records_description = '';
	
	var $faculty_id;
	
	function Config($faculty_id)
	{
		$this->faculty_id = $faculty_id;
	}

	function init()
	{
		global $logged_admin;
		
		$root_dir = dirname(__FILE__) . '/../';
		
		require_once($root_dir . 'config/main.php');

		if (isset($config[$this->faculty_id]))
		{
			$faculty_config = $config[$this->faculty_id];
			
			if (is_file($root_dir . $faculty_config['modificators_include']))
			{
				require_once($root_dir . $faculty_config['modificators_include']);
				
				if (class_exists($faculty_config['modificators_class']))
				{
					$this->modificators_class = $faculty_config['modificators_class'];
				}
			}
			
			if (is_file($root_dir . $faculty_config['records_include']))
			{
				require_once($root_dir . $faculty_config['records_include']);
							
				if (class_exists($faculty_config['records_class']))
				{
					$this->records_class = $faculty_config['records_class'];
				}
			}
			
			if (is_file($root_dir . $faculty_config['rating_include']))
			{
				require_once($root_dir . $faculty_config['rating_include']);
							
				if (class_exists($faculty_config['rating_class']))
				{
					$this->rating_class = $faculty_config['rating_class'];
				}
			}
			
			$this->generic_records_description = $faculty_config['generic_records_description'];
		}
	}
}