<?php

class Modificators extends BasicRecords {
	
	var $modificatorsCache;
	
	function getModificatorByName($modificatorName) {
		if (empty($this->modificatorsCache['names'][$modificatorName])) {
			$this->modificatorsCache['names'][$modificatorName] = $this->db->Quick_fetch("SELECT * FROM tblModificatorTypes WHERE name='".$modificatorName."'");
		}
		
		return $this->modificatorsCache['names'][$modificatorName];
	}
	
	function getModificatorById($modificatorId) {
		if (empty($this->modificatorsCache['ids'][$modificatorId])) {
			$this->modificatorsCache['ids'][$modificatorId] = $this->db->Quick_fetch("SELECT * FROM tblModificatorTypes WHERE modificator_type_id='".$modificatorId."'");
		}
		
		return $this->modificatorsCache['ids'][$modificatorId];
	}
	
	function saveModificatorRecord($recordType, $description, $modificatorTypeId, $modificatorValue) {
		$this->saveRecord($recordType, $description, array('type' => $modificatorId, 'value' => $modificatorValue));
	}
	
	function getModificatorsValue($type = 'modificator') {
	
		$entries = $this->listRecords($type);
		
		$minValue = $maxValue = 0;
		$minType = $maxType = $comment = '';
		
		$comment = array();
		
		foreach ($entries as $entry) {
			
			$modificator = $this->getModificatorById($entry['modificator_type']);
			
			switch ($modificator['computation']) {
				case 'exponencial':
					$partialValue = pow($modificator['value'], $entry['modificator_count']);
				break;
				
				case 'multiplication':
					$partialValue = $modificator['value'] * $entry['modificator_count'];
				break;
			}
			
			$partialValue = (!empty($modificator['limit']) ? min($modificator['limit'], $partialValue) : $partialValue);			
			$partialValue = ($modificator['type'] == 'negative' ? 1 : -1) * $partialValue;
			
			if ($partialValue < $minValue) {
				$minValue = $partialValue;
				$minType = $modificator['name'];
				$comment['min'] = $entry['comment'];
			}
			
			if ($partialValue > $maxValue) {
				$maxValue = $partialValue;
				$maxType = $modificator['name'];
				$comment['max'] = $entry['comment'];
			}		
		}
		
		$result['value'] = round($maxValue + $minValue);
		$result['positive_type'] = $minType;
		$result['negative_type'] = $maxType;
		$result['comment'] = implode(', ', $comment);
		
		return $result;		
	}
	
	function generateGenericModificators() 
	{
		return true;
	}
}

?>