<?
//if(!isset($INCLUDED_XTEMPLATE)){	$INCLUDED_XTEMPLATE='yes';
/*

You may copy and distribute verbatim copies of the Program's source code
as you receive it, in any medium, provided that you conspicuously and
appropriately publish on each copy an appropriate copyright notice and
disclaimer of warranty; keep intact all the notices that refer to this License
and to the absence of any warranty; and give any other recipients of the
Program a copy of this License along with the Program.

*/

class CachedXTemplate{

var $filecontents='';
var $blocks=array();
var $parsed_blocks=array();
var $block_parse_order=array();
var $sub_blocks=array();
var $VARS=array();

var $file_delim="/\{FILE\s*\"(.*?)\"\s*\}/m";
var $block_start_delim='<!-- ';
var $block_end_delim='-->';
var $block_start_word='BEGIN:';
var $block_end_word='END:';

var $NULL_STRING=array(''=>'');
var $NULL_BLOCK=array(''=>'');
var $mainblock='';
var $ERROR='';
var $AUTORESET=1;

var $TEMPLATES=array();

var $CACHEDIR='./cache';
var $CACHELENGTH=30;
var $TIMEUNIT='day';
var $TIMEUNITSARR=array('sec'=>1,'min'=>60,'hour'=>3600,'day'=>86400);

function CachedXTemplate($file,$var_arr='',$mainblock='main',$cachedir='',$cachelen='',$timeunit=''){
	$st='';
	if(gettype($var_arr)=='array'){
		while(list($k,$v)=each($var_arr)){
			$st.=$k.'_'.$v;
		}
		$st='_'.$st;
	}
	if($st && $var_arr){
		global $PHP_SELF;
		$this->fName=str_replace('/','_',$PHP_SELF).$st;

		if(!empty($cachedir))
			$this->set_cache_dir($cachedir);
		if(!empty($cachelen))
			$this->set_cache_length($cachelen);
		if(!empty($timeunit))
			$this->set_time_unit($timeunit);

		if($this->valid_cache_file()){
			$this->read_from_cache();
			exit;
		}
	}
	$this->mainblock=$mainblock;
	$this->filecontents=$this->r_getfile($file);
	$this->blocks=$this->maketree($this->filecontents,$mainblock);
	$this->scan_globals();
}
function set_cache_dir($dir){
	if(substr($dir,(strlen($dir)-1),1)=='/'){
		$dir=substr($dir,0,-1);
	}
	$this->CACHEDIR=$dir;
}
function set_cache_length($length){
	$this->CACHELENGTH=$length;
}
function set_time_unit($str){
	if($this->_is_valid_time_unit($str)){
		$this->TIMEUNIT=$str;
	}else{
		$this->TIMEUNIT='day';
	}
}
function write_to_cache($content){
$content = ereg_replace("([\n\r\t\ ])+"," ",$content);
	$fp=fopen($this->CACHEDIR.'/'.$this->fName.'.cache','w');
	fwrite($fp,$content);
	fclose($fp);
	$timestamp=$this->_mktimestamp();
	$fp=fopen($this->CACHEDIR.'/'.$this->fName.'.cntrl','w');
	fwrite($fp,$timestamp.':'.$this->CACHELENGTH.':'.$this->TIMEUNIT);
	fclose($fp);
}
function read_from_cache(){
	if($this->is_cached()){
		readfile($this->CACHEDIR.'/'.$this->fName.'.cache');
		return true;
	}else{
		return false;
	}
}
function is_cached(){
	return (is_file($this->CACHEDIR.'/'.$this->fName.'.cache')&&
		is_file($this->CACHEDIR.'/'.$this->fName.'.cntrl'));
}
function valid_cache_file(){
	global $PATH_TRANSLATED;
	if ($this->is_cached()){
		$info=file($this->CACHEDIR.'/'.$this->fName.'.cntrl');
		$val=explode(':',$info[0]);
		if(!$this->_is_valid_time_unit($val[2]))
			return false;
		if(filemtime($PATH_TRANSLATED)>=$val[0])
			return false;
		$tpls=$this->getTemplatesList();
		if (count($tpls)>0){
			while(list($index,$fn)=each($tpls)){
				if(is_file($fn)&&(filemtime($fn)>=$val[0]))
					return false;
			}
		}
		$today=$this->_mktimestamp();
		return ($this->_diff_time($today,$val[0],$val[2])<=$val[1]);
	}else{
		return false;
	}
}
function _key_in_array($element,$arr){
	list($major,$minor,$release)=explode('.',phpversion());
	if(($major==3&&$minor==0&&$relesase>=12)||$major==4){
		return in_array($element, array_keys($arr));
	}else{
		while(list($key,$val)=each($arr)){
			if($key==$element) return true;
		}
		return false;
	}
}
function _is_valid_time_unit($str){
	return $this->_key_in_array($str,$this->TIMEUNITSARR);
}
function _mktimestamp(){
	return time();
}
function _diff_time($end,$start,$timeunit='day'){
	$factor=$this->TIMEUNITSARR[$timeunit];
	return intval(($end-$start)/$factor);
}



function assign($name,$val=''){
	if(gettype($name)=='array'){
		while(list($k,$v)=each($name)){
			$this->VARS[$k]=$v;
		}
	}else{
		$this->VARS[$name]=$val;
	}
}
function parse($bname){
	$copy=$this->blocks[$bname];
	if(empty($this->blocks[$bname]))
		$this->set_error ("parse: blockname [$bname] does not exist");
	preg_match_all("/\{([A-Za-z0-9\._]+?)}/",$this->blocks[$bname],$var_array);
	$var_array=$var_array[1];
	while(list($k,$v)=each($var_array)){
		$sub=explode('.',$v);
		if($sub[0]=='_BLOCK_'){
			unset($sub[0]);
			$bname2=implode('.',$sub);
			$var=$this->parsed_blocks[$bname2];
			$nul=(empty($this->NULL_BLOCK[$bname2]))?$this->NULL_BLOCK['']:$this->NULL_BLOCK[$bname2];
			$var=(empty($var))?$nul:$var;
			$copy=ereg_replace("\{".$v."\}","$var",$copy);
		}else{
			$var=$this->VARS;
			while(list($k1,$v1)=each($sub)) $var=$var[$v1];
			$nul=(empty($this->NULL_STRING[$v]))?($this->NULL_STRING['']):($this->NULL_STRING[$v]);
			$var=(empty($var))?$nul:$var;
			$copy=ereg_replace("\{$v\}","$var",$copy);
		}
	} 	
	$this->parsed_blocks[$bname].=$copy;
	if($this->AUTORESET){
		if(!empty($this->sub_blocks[$bname])){
			reset($this->sub_blocks[$bname]);
			while(list($k,$v)=each($this->sub_blocks[$bname]))
				$this->reset($v);
		}
	}
}
function rparse($bname){
	if(!empty($this->sub_blocks[$bname])){
		reset($this->sub_blocks[$bname]);
		while(list($k,$v)=each($this->sub_blocks[$bname])){
			if(!empty($v)) $this->rparse($v,$indent."\t");
		}
	}
	$this->parse($bname);
}
function insert_loop($bname,$var,$value=''){
	$this->assign($var,$value);
	$this->parse($bname);
}
function text($bname){
	if (empty($bname))
		$bname=$this->mainblock;
	return $this->parsed_blocks[$bname];
}
function out($bname){
	echo $this->text($bname);
}
function reset($bname){
	$this->parsed_blocks[$bname]='';
}
function parsed($bname){
	return (!empty($this->parsed_blocks[$bname]));
}
function SetNullString($str,$varname=''){
	$this->NULL_STRING[$varname]=$str;
}
function SetNullBlock($str,$bname=''){
	$this->NULL_BLOCK[$bname]=$str;
}
function set_autoreset(){
	$this->AUTORESET=1;
}
function clear_autoreset(){
	$this->AUTORESET=0;
}
function scan_globals(){
	reset($GLOBALS);
	while (list($k,$v)=each($GLOBALS))
		$GLOB[$k]=$v;
	$this->assign("PHP",$GLOB);
}
function maketree($con,$block){
	$con2=explode($this->block_start_delim,$con);
	$level=0;
	$block_names=array();
	$blocks=array();
	reset($con2);
	while(list($k,$v)=each($con2)){
		$patt="($this->block_start_word|$this->block_end_word)[[:blank:]]*([0-9a-zA-Z\_]+)[[:blank:]]*$this->block_end_delim(.*)";
		if(eregi($patt,$v,$res)){
			if($res[1]==$this->block_start_word){
				$parent_name=implode('.',$block_names);
				$block_names[++$level]=$res[2];
				$cur_block_name=implode('.',$block_names);
				$this->block_parse_order[]=$cur_block_name;
				$blocks[$cur_block_name].=$res[3];
				$blocks[$parent_name].="{_BLOCK_.$cur_block_name}";
				$this->sub_blocks[$parent_name][]=$cur_block_name;
				$this->sub_blocks[$cur_block_name][]='';
			}else if($res[1]==$this->block_end_word){
				unset($block_names[$level--]);
				$parent_name=implode('.',$block_names);
				$blocks[$parent_name].=$res[3];
			}
		}else{
	$cur_block_name=implode('.',$block_names);
	$blocks[$cur_block_name].=$this->block_start_delim.$v;
		}
	}
return $blocks;
}
function get_error(){
	return ($this->ERROR=='')?0:$this->ERROR;
}
function set_error($str){
	$this->ERROR=$str;
}
function r_getfile($file){
	$text=$this->getfile($file);
	while(preg_match($this->file_delim,$text,$res)){
		$text2=$this->getfile($res[1]);
		$text=ereg_replace($res[0],$text2,$text);
	}
	return $text;
}

function getTemplatesList(){
	return $this->TEMPLATES;
}
function getParsedDoc($sect='main'){
	return $this->Text($sect);
}
function getfile($file){
	if(empty($file)){
		$this->set_error('Empty file name!');
		return '';
	}
	if(is_file($file)){
		if(!($fh=fopen($file,'r'))){
			$this->set_error("Cannot open file: $file");
			return '';
		}
		$file_text=fread($fh,filesize($file));
		fclose($fh);
		$this->TEMPLATES[]=$file;
	}else{
		$this->set_error("[$file] does not exist");
		$file_text="<b>__CachedXTemplate fatal error: file [$file] does not exist__</b>";
	}
	return $file_text;
}


} /* end of CachedXTemplate class. */
//}
?>