<?php

require_once('_setup.php');
require_once('_https_switch.php');

$session = new Session();

$state = 'index';
$menuState = '';

$page = new XTemplate('out/tpl/main.tpl');
$menuPanels = array();

$season = getActiveSeason();

$page->assign('SEASON', $season);

if (empty($_REQUEST['faculty_id']))
{
	$menuPanels[] = 'crossroad';
	
	$faculties = getEntities('faculty');
	
	foreach ($faculties as $faculty)
	{
		$page->assign('C_FACULTY', $faculty);		
		$page->parse('main.crossroad_main.faculty');
	}
	
	$page->parse('main.crossroad_main');
}
else
{
	$faculty = getFaculty($_REQUEST['faculty_id']);
	
	$config = new Config($_REQUEST['faculty_id']);
	$config->init();
	
	$active_season_id = Properties::getProperty('active_season_id', 'global');
	
	$faculty['main_title'] = ' - ' . $faculty['abbreviation'];
	
	$page->assign('FACULTY', $faculty);
	
	if (!empty($_POST['dologin'])) {
		
		$user = isCorrectLogin($_POST['login'], $_POST['password']);
		
		if (!empty($user['user_id'])) {
			$session->createSession($user);
			prefillApplication($user);
		}
		else {
			$menuState = 'login';
		}
	}
	
	if (!empty($_POST['logout'])) {
		$session->destroySession();
	}
	
	$user_id = $session->getId();
	$user_type = $session->getType();
	
	$user_is_admin = false;
	
	if (empty($user_id)) {
		$logged = false;
		$user_id = 0;
		
		if (Properties::getProperty('show_login_panel', 'faculty', $faculty['id']) == 'yes') {
			$menuPanels[] = 'login';
		}
	
		if (Properties::getProperty('show_registration_panel_present', 'faculty', $faculty['id']) == 'yes') {
			$menuPanels[] = 'registration';
		}
		
		if (Properties::getProperty('show_registration_panel_new', 'faculty', $faculty['id']) == 'yes') {
			$menuPanels[] = 'registration_new';
		}
	}
	else {
		$logged = true;
		$menuPanels = array('user', 'apply', 'place', 'friend');
	}
	
	$menuPanels[] = 'backlink';
	
	$supressedPanels = array();
	if (Properties::getProperty('supress_login_panel', 'faculty', $faculty['id']) == 'yes') {
		$supressedPanels['login'] = 'supress';
	}

	if (Properties::getProperty('supress_registration_panel_present', 'faculty', $faculty['id']) == 'yes') {
		$supressedPanels['registration'] = 'supress';
	}
	
	if (Properties::getProperty('supress_registration_panel_new', 'faculty', $faculty['id']) == 'yes') {
		$supressedPanels['registration_new'] = 'supress';
	}
	
	
	// states
	
	if (!empty($_GET['show_message'])) {
		$state = 'message_view';
	}
	
	if (!empty($_GET['verify'])) {
		$state = 'verify';
	}
	
	if (!empty($_GET['apply']) && $logged) {
		$state = 'apply';
	}
	
	if (!empty($_GET['places']) && $logged) {
		$state = 'places';
	}
	
	if (!empty($_GET['friends']) && $logged) {
		$state = 'friends';
	}
	
	if (!empty($_GET['friends_groups']) && $logged && $user_is_admin == true) {
		$state = 'friends_groups';
	}
	
	if (!empty($_GET['zoznam'])) {
		switch ($_GET['zoznam']) {
			case 'ziadatelia':
			case 'ziadatelia-novoprijati':
			case 'ziadatelia-jednotky':
			case 'jednotky':
			case 'izby':
			case 'definovany':
				$state = 'zoznam-'.$_GET['zoznam'];
			break;
		}
	}
	
	if (!empty($_REQUEST['register'])) {
		$menuState = 'register';
	}
	
	if (!empty($_REQUEST['register_new'])) {
		$menuState = 'register_new';
	}
	
	$page->assign('SUPRESS', $supressedPanels);
	
	if ($menuState == 'register' || $menuState == 'register_new') {
		
		if ($menuState == 'register')
		{
			$register_type = 'present';
			$tpl_suffix = '';
		}
		else
		{
			$register_type = 'new';
			$tpl_suffix = '_new';
		}
		
		$error = '';
		$can_register = true;

		if (!isset($_REQUEST['duplicities']))
		{
			if ($register_type == 'present' && empty($_POST['isic'])) {
				$error = 'Nezadali ste ISIC slo tudenta. Ak Vae ISIC slo neviete, njdete ho na Vaom tudentskom preukaze.';
			}
			elseif ($register_type == 'present' && !isValidISIC($_POST['isic'])) {
				$error = 'Zadan ISIC slo tudenta sa v univerzitnej databze nenachdza. Ak ste si ist, e ste sa pri jeho zadvan nepomlili, potom pravdepodobne V tudentsk preukaz nie je validovan. V tom prpade najprv chote na tdijn oddelenie a validujte si ho.';
			}
			elseif ($register_type == 'new' && empty($_POST['birth_number'])) {
				$error = 'Nezadali ste rodn slo tudenta.';
			}
			elseif ($register_type == 'new' && !isValidBirthNumber($_POST['birth_number'])) {
				$error = 'Zadan rodn slo tudenta sa nenachdza v naej databze. Ak ste sa pomlili, tak zadajte rodn slo ete raz. V prpade, e zadvate sprvne rodn slo a stle vidte toto upozornenie polite e-mail ubytovacej komisii a spolone tento problm vyrieime.';
			}
			elseif (empty($_POST['login']) || empty($_POST['e_mail_address'])) {
				$error = 'Nezadali ste vetky daje.';
			}
			elseif (isLoginExists($_POST['login'])) {
				$error = 'Zadan prihlasovacie meno nie je von. Zvote si in.';
			}
			elseif (isEmailAddressExists($_POST['e_mail_address'])) {
				$error = 'Zadan e-mailov adresa je u pouit. Zvote si in.';
			}
			elseif (empty($_POST['password']) || empty($_POST['password_verify'])) {
				$error = 'Heslo alebo jeho overenie s przdne. Zvote si prosm heslo.';
			}
			elseif ($_POST['password'] != $_POST['password_verify']) {
				$error = 'Heslo a jeho overenie nie s rovnak.';
			}
	
			if (empty($error))
			{
				$students = getStudentsForIdentificator($_POST['isic'], $_POST['birth_number']);
			
				if (count($students) > 1)
				{
					$_SESSION['duplicities_data'] = $_POST;
					$can_register = false;
		
					$i = 0;
					foreach ($students as $student)
					{
						$i++;
						$_SESSION['duplicities'][$i] = $student;		
						
						$student['id'] = $i;
		
						$page->assign('DUPLICITY', $student);
						$page->parse('main.registration' . $tpl_suffix . '.duplicities.duplicity');
					}
					
					$page->parse('main.registration' . $tpl_suffix . '.duplicities');
				}
				else
				{
					$register_form_data = $_POST;
				}
			}
			else
			{
				$register_form_data = $_POST;
			}
		}
		else
		{
			if (isset($_SESSION['duplicities_data']))
			{
				$register_form_data = $_SESSION['duplicities_data'];
				$register_form_data['student_id'] = $_SESSION['duplicities'][$_REQUEST['id']]['student_id'];
			
				unset($_SESSION['duplicities']);
				unset($_SESSION['duplicities_data']);
			}
			else
			{
				$can_register = false;
			}
		}
		
		if ($can_register)
		{		
			if (empty($error)) {
				
				registerUser($register_form_data, $register_type);
							
				$page->parse('main.registration' . $tpl_suffix . '_verification_form');
				$page->assign('E_MAIL_ADDRESS', htmlspecialchars(stripslashes($register_form_data["e_mail_address"])));
				$page->parse('main.registration' . $tpl_suffix . '.done');
			}
			else {
				$page->assign('DATA', $register_form_data);
				$page->assign('ERROR', $error);
				$page->parse('main.registration' . $tpl_suffix . '.form.error');
				$page->parse('main.registration' . $tpl_suffix . '.form');
			}
		}	
	}
	
	if ($menuState != 'register') {
			$page->parse('main.registration.form');
	}
	
	if ($menuState != 'register_new') {
			$page->parse('main.registration_new.form');
	}
	
	if ($menuState == 'login') {
		
		$error = 'Zadali ste nesprvne prihlasovacie daje, alebo ste ete neoverili Vau registrciu, alebo sa prihlasujete na nesprvnej fakulte.';
				
		$page->assign('ERROR', $error);
		$page->assign('LOGINDATA', $_POST);
		$page->parse('main.login.error');
	}
	
	#############################################################################
	## index state ##############################################################
	#############################################################################
	
	// messages
	$globalMessages = new Messages($user_id, $db);
	
	if ($state == 'index') {
		$gMessages = $globalMessages->getGlobalMessages();
		
		if (count($gMessages)) {
			foreach ($gMessages as $gMessage) {
				
				if (empty($gMessage['url'])) {
					$gMessage['URL'] = 'index.php?show_message='.$gMessage['message_id'] . '&amp;faculty_id=' . $faculty['id'];
				}
				else {
					$gMessage['URL'] = $gMessage['url'];
				}
				
				$gMessage['creation_date'] = substr($gMessage['creation_date'], 0, 10);
	
				if (preg_match("-^\w+://-", $gMessage['URL'])>0)
				{
					$gMessage['TARGET'] = ' target="_blank"';
				}
				
				$page->assign('GLOBAL_MESSAGE', $gMessage);
					
				if ($gMessage['publish'] == 'temporary') {
					$col = 2;
				}
				else {
					$col = 1;
				}
			
				if (!empty($gMessage['perex'])) {
					$page->parse('main.global_messages.messagecol'.$col.'.perex');
				}
				
				$page->parse('main.global_messages.messagecol'.$col);
			}
			
			$page->parse('main.global_messages');
		}
		
		$gMessage = $globalMessages->getMainMessage();
		showMessage($page, $gMessage, false);
		
	}
	
	#############################################################################
	## message state ############################################################
	#############################################################################
	
	if ($state == 'message_view') {
		$gMessage = $globalMessages->getGlobalMessage($_GET['show_message']);
		showMessage($page, $gMessage);
	}
	
	#############################################################################
	## message state ############################################################
	#############################################################################
	
	if ($state == 'apply') {
		
		$step = (empty($_GET['step']) ? 1 : $_GET['step']);
		$fields = array('student_id', 'name', 'surname', 'sex', 'address', 'city', 'psc', 'type', 'section', 'year', 'sameroom', 'smoking', 'distance', 'message');
		
		$gMessage = $globalMessages->getApplyMessage($step);
		showMessage($page, $gMessage, false);
		
		if (Properties::getProperty('allow_edit_application', 'faculty', $faculty['id']) == 'yes') {	
			switch ($step) {
			
				case 1:
					
					$study_types = getStudyTypes($faculty['id']);
					
					$requiredFields = array('name', 'surname', 'sex', 'address', 'city', 'psc', 'type', 'section', 'year', 'smoking', 'distance');
							
					$errorFields = array();
					$errorMarks = array();
					$isError = false;
				
					//$apply = loadApplication($user_id);
					$apply = prefillApplication(array('user_id' => $user_id, 'user_type' => $user_type));
					
					$saved = false;
					if (count($apply)) {
						$saved = true;
					}
					
					if ($_POST['proceed']) {
						unset($_POST['proceed']);
						$apply = $_POST;
						
						$userDataObj = new User($db);
						$userData = $userDataObj->getUserData($user_id);
	
						$apply['student_id'] = $userData['user']['internal']['student_id'];
						
						foreach ($requiredFields as $requiredField) {
							if (empty($_POST[$requiredField])) {
								$errorFields[$requiredField] = ' class="error"';
								$errorMarks[$requiredField] = '<strong>X</strong>';
								$isError = true;
							}
							else {
								$errorFields[$requiredField] = '';
								$errorMarks[$requiredField] = '';
							}
						}
		
						if (!$isError) {
							
							if (empty($apply['sameroom'])) {
								$apply['sameroom'] = 'no';
							}
							
							saveApplication($user_id, $apply, $fields);

							if ($apply['sameroom'] == 'yes') {
								
								$place_data = getLastYearPlace($user_id);
								
								if (!isPlaceRequestedThisYear($user_id, $place_data)) 
								{
									$placeId = addPlace($user_id);
									$a = $apply['sex'] == 'female' ? 'a' : '';
									setPlaceDescription($placeId, 'Tto izbu by som chcel'.$a.', pretoe som ju mal'.$a.' pred rokom.');
									setPlaceFlag($placeId, 'last_year');
									
									if (count($place_data) > 0)
									{
										setPlacesData($placeId, $place_data);
									}
								}
								
								header('Location: index.php?apply=true&step=2&place_id='.$placeId . '&faculty_id=' . $faculty['id']);
							}
							else {
								header('Location: index.php?apply=true&step=3' . '&faculty_id=' . $faculty['id']);
							}
							
							die();
						}
						else {
							$page->parse('main.apply_form.error');
						}
						
					}
						
					$select['sex'][$apply['sex']] = ' selected="selected"';
					$select['smoking'][$apply['smoking']] = ' selected="selected"';
					$select['type'][$apply['type']] = ' selected="selected"';
					$select['sameroom'][$apply['sameroom']] = ' selected="selected"';
					$select['year']['y'.$apply['year']] = ' selected="selected"';
					
					$page->assign('APPLY', $apply);
					$page->assign('SELECT', $select);
							
					$page->assign('ERROR', $errorFields);
					$page->assign('ERRORMARK', $errorMarks);
		
					$sections = getStudySections($faculty['id']);
					
					foreach ($sections as $section) {
						if ($apply['section'] == $section['value']) {
							$section['selected'] = ' selected="selected"';
						}
						else {
							$section['selected'] = '';
						}
						
						$page->assign('SECTION', $section);
						$page->parse('main.apply_form.section');
					}
					
					if ($user_type == 'present') {
						$page->parse('main.apply_form.sameroom');
					}
					
					foreach ($study_types as $study_type)
					{
						$study_type['selected'] = $apply['type'] == $study_type['id'] ? ' selected="selected"' : '';

						$page->assign('STUDY_TYPE', $study_type);
						$page->parse('main.apply_form.study_type');
					}
					
					$page->parse('main.apply_form');
				break;
				
				case 2:
					$content = editPlace($_GET['place_id'], 'ONE', 'WITHOUT_INFO', array('apply', 'step'));
					if ($content == 'DONE') {
						header('Location: index.php?apply=true&step=3' . '&faculty_id=' . $faculty['id']);
						die();
					}
					else {
						$page->assign('ROOMSELECT_CONTENT', $content);
						$page->parse('main.apply_form_room_select');
					}
				break;
			}
		}
	}
	
	#############################################################################
	## places state #############################################################
	#############################################################################
	
	if ($state == 'places') {
		$gMessage = $globalMessages->getPlacesMessage();
		showMessage($page, $gMessage, false);
		
		if (Properties::getProperty('allow_edit_places', 'faculty', $faculty['id']) == 'yes') {
			if ($_REQUEST['add'] == 'true' && count($places) < 5) {
				$placeId = addPlace($user_id);
				header('Location: index.php?places=true&place_id='.$placeId . '&faculty_id=' . $faculty['id']);
				die();
			}
			elseif($_REQUEST['delete'] == 'true' && !empty($_REQUEST['place_id'])) {
				deletePlace($_REQUEST['place_id']);
				header('Location: index.php?places=true' . '&faculty_id=' . $faculty['id']);
				die();
			}
			elseif($_REQUEST['moveup'] == 'true' && !empty($_REQUEST['place_id'])) {
				movePlace($user_id, $_REQUEST['place_id'], 'up');
				header('Location: index.php?places=true' . '&faculty_id=' . $faculty['id']);
				die();
			}
			elseif($_REQUEST['movedown'] == 'true' && !empty($_REQUEST['place_id'])) {
				movePlace($user_id, $_REQUEST['place_id'], 'down');
				header('Location: index.php?places=true' . '&faculty_id=' . $faculty['id']);
				die();
			}
			elseif (!empty($_REQUEST['place_id'])) {
				
					$content = editPlace($_REQUEST['place_id'], 'MANY', 'WITH_INFO', array('places', 'add'));
					
					if ($content == 'DONE') {
						$content = '<strong>Informcie o zvolenom mieste boli uloen.</strong>';
					}
				
					$page->assign('ROOMSELECT_CONTENT', $content);
					$page->parse('main.apply_form_room_select');
			}
			else {
				$places = loadPlaces($user_id);
				if (count($places)) {
					$first = true;
					foreach ($places as $place) {
									
						$placeRow = loadPlace($place['place_id']);
						
						
										
						$place['content'] = getHumanNameOfThePlace($place['place_id']);
						$place['description'] = htmlspecialchars(stripslashes($placeRow['description']));
		
						if ($placeRow['flag'] == 'last_year') {
							$place['content'] .= ' (ako tento rok)';
						}
						
						if ($first) {
							$place['content'] = '<strong>'.$place['content'].'</strong>';
						}
						
						$first = false;
						$page->assign('PLACE', $place);
						$page->parse('main.places.list.item');
					}
					$page->parse('main.places.list');
				}
				else {
					$page->parse('main.places.noplaces');
				}
		
				if (count($places) < 5) {
					$page->parse('main.places.addbutton');
				}
			}
		}
		
		$page->parse('main.places');
	}
	
	#############################################################################
	## friend state #############################################################
	#############################################################################
	
	if (empty($_REQUEST['friend_id'])) {
		$db->Query("DELETE FROM tblUserFriends WHERE login IS NULL AND user_id='".$user_id."'");
	}
	
	if ($state == 'friends') {
		$gMessage = $globalMessages->getFriendsMessage();
		showMessage($page, $gMessage, false);
		
		if (Properties::getProperty('allow_edit_friends', 'faculty', $faculty['id']) == 'yes') {
			if ($_REQUEST['add'] == 'true') {
				$friendId = addFriend($user_id);
				header('Location: index.php?friends=true&friend_id='.$friendId . '&faculty_id=' . $faculty['id']);
				die();
			}
			elseif($_REQUEST['delete'] == 'true' && !empty($_REQUEST['friend_id'])) {
				$db->Query("DELETE FROM tblUserFriends WHERE friend_id = '".$_REQUEST['friend_id']."'");
				header('Location: index.php?friends=true' . '&faculty_id=' . $faculty['id']);
				die();
			}
			elseif (!empty($_REQUEST['friend_id'])) {
				
					$content = editFriend($user_id, $_REQUEST['friend_id']);
					
					if ($content == 'DONE') {
						$content = '<strong>Zvolen kamart bol pridan do zoznamu.</strong>';
					}
				
					$page->assign('FRIEND_CONTENT', $content);
					$page->parse('main.edit_friend');
			}
			else {
				$friends = $db->GetResults("SELECT * FROM tblUserFriends WHERE user_id ='".$user_id."'");
				if (count($friends)) {
		
					foreach ($friends as $friend) {
		
						$friend['description'] = htmlspecialchars(stripslashes($friend['description']));
						
						$page->assign('FRIEND', $friend);
						$page->parse('main.friends.list.item');
					}
					$page->parse('main.friends.list');
				}
				else {
					$page->parse('main.friends.nofriends');
				}
		
				$page->parse('main.friends.addbutton');
			}
		}
		
		$page->parse('main.friends');
	}
	
	#############################################################################
	## friends groups ###########################################################
	#############################################################################
	
	if ($state == 'friends_groups') {
		
		
		$page->parse('main.friends_groups');
	}
	
	#############################################################################
	## verify state ############################################################
	#############################################################################
	
	if ($state == 'verify') {
		$gMessage['subject'] = 'Overenie registrcie';
		
		$result = verifyRegistration($_GET['verify']);
		
		switch ($result) {
			case 'OK':
				$gMessage['body'] = '<p>Registrcia bola spene overen. Mete sa prihlsi.</p>';
			break;
			case 'ALREADY_OK':
				$gMessage['body'] = '<p>Tto registrcia u bola overen. Nie je potrebn overova ju znovu. Mete sa prihlsi.</p>';
			break;
			default:
			case 'FAIL':
				$gMessage['body'] = '<p>Nesprvny overovac reazec.</p>';
			break;
			
		}
		showMessage($page, $gMessage, false);
	}
	
	#############################################################################
	## show menu panels #########################################################
	#############################################################################
	
	if ($logged) {
		
		if (!hasUserApplication($user_id)) {
			$page->assign('ALERT_MESSAGE', 'Upozornenie: Zatia ste nevyplnili a neuloili iados o ubytovanie. Kliknite na tlatko upravi v paneli "iados". Zobraz sa formulr iadosti s predvyplnenmi dajmi. Mete ich v prpade potreby doplni alebo zmeni. Po doplnen dajov <strong>ULOTE iados</strong> kliknutm na tlatko "Uloi a pokraova". Zadvajte vdy pravdiv daje.');
			$page->parse('main.general_alert');
		}
		
		$user = $db->GetResult("SELECT login FROM tblUsers WHERE user_id='".$user_id."'");
		$page->assign('LOGIN', $user['login']);
		
		$apply = loadApplication($user_id);
		
		$studentInfo = $db->GetResult("
			SELECT 
				*
			FROM 
				tblStudents
			where
				student_id = '".getStudentIdForUser($user_id)."'");
	
	
		if (count($apply)) {
	
			$apply['rating'] = (!empty($studentInfo['rating']) ? $studentInfo['rating'] : '---------');
			
			$page->assign('APPLYINFO', $apply);
			
			if (Properties::getProperty('allow_edit_application', 'faculty', $faculty['id']) == 'yes') {
				$page->parse('main.apply.button');
			}
	
			if (Properties::getProperty('allow_edit_places', 'faculty', $faculty['id']) == 'yes') {
				$page->parse('main.place.button');
			}
			
			if (Properties::getProperty('allow_edit_friends', 'faculty', $faculty['id']) == 'yes') {
				$page->parse('main.friend.button');
			}
			
			$page->parse('main.apply.info');
		}
		else {		
			$page->parse('main.apply.description');
		}
	
		
		$places = loadPlaces($user_id);
		if (count($places)) {
			$first = true;
			foreach ($places as $place) {
				
				$placeContent = getHumanNameOfThePlace($place['place_id']);
				$placeRow = loadPlace($place['place_id']);
				if ($placeRow['flag'] == 'last_year') {
					$placeContent .= ' (ako tento rok)';
				}
				
				if ($first) {
					$placeContent = '<strong>'.$placeContent.'</strong>';
				}
				
				$first = false;
				$page->assign('PLACE', $placeContent);
				$page->parse('main.place.list.item');
			}
			$page->parse('main.place.list');
		}
		else {
			$page->parse('main.place.description');
		}
		
		$friends = $db->GetResults("SELECT * FROM tblUserFriends WHERE user_id ='".$user_id."'");
		if (count($friends)) {
			
			$friendsArray = array();
			foreach ($friends as $friend) {
				if (!empty($friend['login'])) {
					$friendsArray[] = $friend['login'];
				}
			}			
			
			if (count($friendsArray)) {
				$page->assign('FRIENDS', implode(', ', $friendsArray));
				$page->parse('main.friend.list');
			}
			else {
				$page->parse('main.friend.description');
			}
		}
		else {
			$page->parse('main.friend.description');
		}
	
	}

	if ($user_is_admin) {
		$page->parse('main.admin');
	}
}	

foreach ($menuPanels as $menuPanel) {
	$page->parse('main.'.$menuPanel);
}


//$page->parse('main.message');
$page->parse('main');
$page->out('main');

?>
