/*
SQLyog - Free MySQL GUI v5.15
Host - 5.0.32-Debian_7etch5 : Database - likavcan_ubytovanie
*********************************************************************
Server version : 5.0.32-Debian_7etch5
*/


SET NAMES utf8;

SET SQL_MODE='';
SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO';

/*Table structure for table `tblAdmins` */

CREATE TABLE `tblAdmins` (
  `admin_id` int(11) NOT NULL auto_increment,
  `login` varchar(255) default NULL,
  `password` varchar(32) default NULL,
  `is_superadmin` tinyint(1) default NULL,
  PRIMARY KEY  (`admin_id`)
) ENGINE=MyISAM AUTO_INCREMENT=6 DEFAULT CHARSET=latin1;

/*Table structure for table `tblAdminsEntitiesRights` */

CREATE TABLE `tblAdminsEntitiesRights` (
  `admin_id` int(11) default NULL,
  `entity_type` enum('faculty','dormitory') default NULL,
  `entity_id` int(11) default NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

/*Table structure for table `tblAdminsRights` */

CREATE TABLE `tblAdminsRights` (
  `admin_id` int(11) default NULL,
  `section_id` int(11) default NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

/*Table structure for table `tblApplicationsInCustomLists` */

CREATE TABLE `tblApplicationsInCustomLists` (
  `list_id` int(11) default NULL,
  `user_id` int(11) default NULL,
  KEY `list_id` (`list_id`),
  KEY `user_id` (`user_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

/*Table structure for table `tblApplicationsList` */

CREATE TABLE `tblApplicationsList` (
  `order_no` int(11) NOT NULL auto_increment,
  `user_id` int(11) default NULL,
  `faculty_id` int(11) default NULL,
  PRIMARY KEY  (`order_no`),
  KEY `user_id` (`user_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

/*Table structure for table `tblApplicationsListFilters` */

CREATE TABLE `tblApplicationsListFilters` (
  `filter_id` int(11) NOT NULL auto_increment,
  `name` varchar(255) default NULL,
  `sql_query` text,
  `order_no` int(11) default NULL,
  PRIMARY KEY  (`filter_id`)
) ENGINE=MyISAM AUTO_INCREMENT=13 DEFAULT CHARSET=latin1;

/*Table structure for table `tblAssignedPlaces` */

CREATE TABLE `tblAssignedPlaces` (
  `place_id` int(10) unsigned NOT NULL default '0',
  `faculty_id` int(10) unsigned default NULL,
  `season_id` int(10) unsigned default NULL,
  `user_id` int(11) NOT NULL default '0',
  `date` int(11) unsigned default NULL,
  `note` text,
  KEY `id_clovek index` (`user_id`),
  KEY `id_vlastnik` (`faculty_id`),
  KEY `place_id` (`place_id`),
  KEY `season_id` (`season_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

/*Table structure for table `tblBlocks` */

CREATE TABLE `tblBlocks` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `locality_id` int(10) unsigned default NULL,
  `name` varchar(10) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=39 DEFAULT CHARSET=latin1;

/*Table structure for table `tblCustomLists` */

CREATE TABLE `tblCustomLists` (
  `list_id` int(11) NOT NULL auto_increment,
  `name` varchar(255) default NULL,
  `faculty_id` int(11) default NULL,
  PRIMARY KEY  (`list_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

/*Table structure for table `tblDormitories` */

CREATE TABLE `tblDormitories` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(255) default NULL,
  `abbreviation` varchar(20) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=latin1;

/*Table structure for table `tblFaculties` */

CREATE TABLE `tblFaculties` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `name` varchar(255) default NULL,
  `abbreviation` varchar(20) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=7 DEFAULT CHARSET=latin1;

/*Table structure for table `tblGlobalMessages` */

CREATE TABLE `tblGlobalMessages` (
  `message_id` int(11) NOT NULL auto_increment,
  `subject` varchar(255) default NULL,
  `perex` text,
  `body` longtext,
  `url` varchar(255) default NULL,
  `creation_date` datetime default NULL,
  `publish_date_from` datetime default NULL,
  `publish_date_till` datetime default NULL,
  `publish` enum('forever','temporary') default 'forever',
  `message_tag` varchar(255) default NULL,
  `list_tag` varchar(30) default NULL,
  `faculty_id` int(11) default NULL,
  PRIMARY KEY  (`message_id`)
) ENGINE=MyISAM AUTO_INCREMENT=80 DEFAULT CHARSET=latin1;

/*Table structure for table `tblLocalities` */

CREATE TABLE `tblLocalities` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `name` varchar(255) default NULL,
  `abbreviation` varchar(10) default NULL,
  `dormitory_id` int(11) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=5 DEFAULT CHARSET=latin1;

/*Table structure for table `tblModificatorTypes` */

CREATE TABLE `tblModificatorTypes` (
  `modificator_type_id` int(11) NOT NULL auto_increment,
  `name` varchar(255) NOT NULL default '',
  `value` double default NULL,
  `computation` enum('multiplication','exponencial') default NULL,
  `limit` double default NULL,
  `type` enum('positive','negative') default NULL,
  `faculty_id` int(11) default NULL,
  PRIMARY KEY  (`modificator_type_id`),
  UNIQUE KEY `name` (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

/*Table structure for table `tblPlaces` */

CREATE TABLE `tblPlaces` (
  `place_id` int(11) NOT NULL auto_increment,
  `room_id` int(11) default NULL,
  PRIMARY KEY  (`place_id`)
) ENGINE=MyISAM AUTO_INCREMENT=903 DEFAULT CHARSET=latin1;

/*Table structure for table `tblProperties` */

CREATE TABLE `tblProperties` (
  `property_tag` varchar(255) NOT NULL default '',
  `property_value` varchar(255) default NULL,
  `property_type` enum('faculty','global') default 'global',
  `entity_id` int(11) default '0',
  KEY `property_tag` (`property_tag`),
  KEY `property_value` (`property_value`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

/*Table structure for table `tblRecordTypes` */

CREATE TABLE `tblRecordTypes` (
  `record_type_id` int(11) NOT NULL auto_increment,
  `record_type_tag` varchar(255) NOT NULL default '',
  `record_type_name` varchar(255) default NULL,
  `list_position` enum('computed','top','bottom','removed') default NULL,
  `group_position` int(11) default NULL,
  `use_points` enum('yes','no') default 'no',
  `faculty_id` int(11) default NULL,
  `priority_no` int(11) default NULL,
  PRIMARY KEY  (`record_type_id`,`record_type_tag`),
  UNIQUE KEY `record_type_tag` (`record_type_tag`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

/*Table structure for table `tblRooms` */

CREATE TABLE `tblRooms` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `block_id` int(10) unsigned default NULL,
  `capacity` int(10) unsigned default NULL,
  `type` enum('internet','bezne') default 'bezne',
  `floor` int(11) default NULL,
  `number` int(11) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=4284 DEFAULT CHARSET=latin1;

/*Table structure for table `tblSeasons` */

CREATE TABLE `tblSeasons` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `name` varchar(255) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=5 DEFAULT CHARSET=latin1;

/*Table structure for table `tblSections` */

CREATE TABLE `tblSections` (
  `section_id` int(11) NOT NULL auto_increment,
  `section_tag` varchar(255) default NULL,
  `section_name` varchar(255) default NULL,
  `order_no` int(11) default NULL,
  PRIMARY KEY  (`section_id`)
) ENGINE=MyISAM AUTO_INCREMENT=17 DEFAULT CHARSET=latin1;

/*Table structure for table `tblStudentHistory` */

CREATE TABLE `tblStudentHistory` (
  `student_id` varchar(10) default NULL,
  `history_action` varchar(10) default NULL,
  `start_year` int(11) default NULL,
  `end_year` int(11) default NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

/*Table structure for table `tblStudents` */

CREATE TABLE `tblStudents` (
  `student_id` varchar(8) default NULL,
  `title` varchar(10) default NULL,
  `name` varchar(20) default NULL,
  `surname` varchar(30) default NULL,
  `address` varchar(255) default NULL,
  `city` varchar(255) default NULL,
  `psc` varchar(10) default NULL,
  `type` int(11) default NULL,
  `year` int(11) default NULL,
  `section` int(10) default NULL,
  `distance` double default NULL,
  `duration` double default NULL,
  `sex` char(2) default NULL,
  `rating` double default NULL,
  `ISIC` varchar(10) default NULL,
  `ISIC_other` varchar(12) default NULL,
  `rating1` double default NULL,
  `rating2` double default NULL,
  `rating3` double default NULL,
  `rating_profile1` double default NULL,
  `rating_profile2` double default NULL,
  `rating_profile3` double default NULL,
  `birth_number` varchar(20) default NULL,
  `student_type` enum('new','present') default 'present',
  `faculty_id` int(11) default NULL,
  KEY `student_id` (`student_id`),
  KEY `type` (`type`),
  KEY `sex` (`sex`),
  KEY `section` (`section`),
  KEY `ISIC` (`ISIC`),
  KEY `birth_number` (`birth_number`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

/*Table structure for table `tblStudySections` */

CREATE TABLE `tblStudySections` (
  `section_id` int(11) NOT NULL auto_increment,
  `code` varchar(255) default NULL,
  `abbreviation` varchar(10) default NULL,
  `name` varchar(255) default NULL,
  `faculty_id` int(11) default NULL,
  PRIMARY KEY  (`section_id`)
) ENGINE=MyISAM AUTO_INCREMENT=141 DEFAULT CHARSET=latin1;

/*Table structure for table `tblStudyTypes` */

CREATE TABLE `tblStudyTypes` (
  `id` int(11) NOT NULL auto_increment,
  `faculty_id` int(11) default NULL,
  `tag` varchar(20) default NULL,
  `name` varchar(50) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=9 DEFAULT CHARSET=latin1;

/*Table structure for table `tblUserApplications` */

CREATE TABLE `tblUserApplications` (
  `user_id` int(11) NOT NULL default '0',
  `student_id` varchar(10) default NULL,
  `title` varchar(10) default NULL,
  `name` varchar(20) default NULL,
  `surname` varchar(30) default NULL,
  `sex` enum('male','female') default NULL,
  `address` varchar(255) default NULL,
  `city` varchar(255) default NULL,
  `psc` varchar(10) default NULL,
  `type` int(11) default NULL,
  `year` int(11) default NULL,
  `section` int(11) default NULL,
  `smoking` enum('no','yes') default NULL,
  `distance` double default NULL,
  `duration` double default NULL,
  `message` text,
  `sameroom` enum('yes','no') default NULL,
  `status` enum('undecided','successful','unsuccessful') NOT NULL default 'undecided',
  `faculty_id` int(11) default NULL,
  PRIMARY KEY  (`user_id`),
  KEY `student_id` (`student_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

/*Table structure for table `tblUserApplicationsRecords` */

CREATE TABLE `tblUserApplicationsRecords` (
  `record_id` int(11) NOT NULL auto_increment,
  `user_id` int(11) default NULL,
  `record_type` varchar(255) default NULL,
  `comment` text,
  `modificator_type` int(11) default NULL,
  `modificator_count` int(11) default NULL,
  PRIMARY KEY  (`record_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

/*Table structure for table `tblUserFriends` */

CREATE TABLE `tblUserFriends` (
  `friend_id` int(11) NOT NULL auto_increment,
  `user_id` int(11) default NULL,
  `login` varchar(255) default NULL,
  `description` text,
  `mutual` enum('no','yes') default 'no',
  PRIMARY KEY  (`friend_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

/*Table structure for table `tblUserPlaces` */

CREATE TABLE `tblUserPlaces` (
  `place_id` int(11) NOT NULL auto_increment,
  `user_id` int(11) default NULL,
  `description` text,
  `location` int(11) default '0',
  `block` int(11) default '0',
  `room` int(11) default '0',
  `has_internet` enum('yes','no') default 'no',
  `is_oneplace` enum('yes','no') default 'no',
  `order_no` int(11) default NULL,
  `flag` varchar(255) default NULL,
  PRIMARY KEY  (`place_id`),
  KEY `locality_id` (`location`),
  KEY `block_id` (`block`),
  KEY `room_id` (`room`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

/*Table structure for table `tblUsers` */

CREATE TABLE `tblUsers` (
  `user_id` int(11) NOT NULL auto_increment,
  `login` varchar(255) default NULL,
  `password` varchar(32) default NULL,
  `e_mail_address` varchar(255) default NULL,
  `verified` enum('yes','no') default 'no',
  `verification_date` datetime default NULL,
  `verification_hash` varchar(255) default NULL,
  PRIMARY KEY  (`user_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

/*Table structure for table `tblUsersToStudentsBindings` */

CREATE TABLE `tblUsersToStudentsBindings` (
  `student_id` varchar(15) default NULL,
  `user_id` int(11) default NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

SET SQL_MODE=@OLD_SQL_MODE;